#include <bits/stdc++.h>

using namespace std;
const int MAXN = 200000;
const int INF = 1e9;
int par[MAXN + 1], dp[MAXN + 1], costp[MAXN + 1], vin[MAXN + 1], vout[MAXN + 1], aint[4 * MAXN], aint2[4 * MAXN], v[MAXN + 1], costp2[MAXN + 1];
struct nume {
    int val, poz, fiu;
} v2[MAXN + 2];
vector<int> adj[MAXN + 1];
vector<int> cost[MAXN + 1];
map<int, int> fr[MAXN + 1];//tin la fiecare
int n, k, rez, time1, maxr, mij, maxp, k2;
char cmp(nume a, nume b) {
    return a.val > b.val;
}
void dfs(int nod) {
    int nr, i, x, max1, max2, c;
    time1++;
    v[time1] = nod;
    vin[nod] = time1;
    nr = adj[nod].size();
    max1 = max2 = -INF;
    for (i = 0; i < nr; i++) {
        x = adj[nod][i];
        c = cost[nod][i];
        if (par[x] < 0) {
            costp2[x] = costp[x] = c;
            par[x] = nod;
            dfs(x);
            if (dp[x] + c > dp[nod]) {
                dp[nod] = dp[x] + c;
            }
            if (dp[x] + c > max1) {
                max2 = max1;
                max1 = dp[x] + c;
            } else if (dp[x] + c > max2) {
                max2 = dp[x] + c;
            }
        }
    }
    if (max1 > 0 && max2 > 0 && max1 + max2 > rez) {
        rez = max1 + max2;
    } else if (max1 > 0 && max1 > rez) {
        rez = max1;
    }
    vout[nod] = time1;
}
int maxim(int a, int b) {
    return a > b ? a : b;
}
void build(int nod, int st, int dr) {
    int mid;
    if (st == dr) {
        aint2[nod] = aint[nod] = dp[v[st]] + costp[v[st]];//in v[st] este nodul din arbore de la acel timp
    } else {
        mid = (st + dr) / 2;
        build(2 * nod, st, mid);
        build(2 * nod + 1, mid + 1, dr);
        aint[nod] = maxim(aint[2 * nod], aint[2 * nod + 1]);
    }
}
void update(int nod, int st, int dr, int poz, int val) {
    int mid;
    if (st == dr) {
        if (val > 0 && aint[nod] >= 0) {
            aint[nod] = val;
        } else {
            costp[poz]--;
            if (costp[poz] <= 0) {
                aint[nod] = -1;
            } else {
                aint[nod]--;
            }
        }
    } else {
        mid = (st + dr) / 2;
        if (poz <= mid) {
            update(2 * nod, st, mid, poz, val);
        } else {
            update(2 * nod + 1, mid + 1, dr, poz, val);
        }
        aint[nod] = maxim(aint[2 * nod], aint[2 * nod + 1]);
    }
}
void query(int nod, int st, int dr, int x, int y) {
    int mid;
    if (x <= st && y >= dr) {
        if (aint[nod] > maxr) {
            maxr = aint[nod];
            maxp = v[st];//nodul din arbore
        }
    } else {
        mid = (st + dr) / 2;
        if (x <= mid) {
            query(2 * nod, st, mid, x, y);
        }
        if (y > mid) {
            query(2 * nod + 1, mid + 1, dr, x, y);
        }
        aint[nod] = maxim(aint[2 * nod], aint[2 * nod + 1]);
    }
}
void dfs2(int nod) {
    int nr, i, x, c, nrc, xp;
    nr = adj[nod].size();
    for (i = 0; i < nr; i++) {
        x = adj[nod][i];
        if (par[x] == nod) {
            dfs2(x);
        }
    }
    nrc = 0;
    for (i = 0; i < nr; i++) {
        x = adj[nod][i];
        c = cost[nod][i];
        if (par[x] == nod) {
            maxr = -INF;
            query(1, 1, n, vin[x], vout[x]);
            if (maxr >= 0) {
                v2[nrc].val = maxr;
                v2[nrc].poz = maxp;
                v2[nrc].fiu = x;
                nrc++;
            }
        }
    }
    v2[nrc].val = 0;
    v2[nrc].poz = -1;
    nrc++;
    if (nrc > 1) {
        sort(v2, v2 + nrc, cmp);
        //verif daca merge sol
        while (k2 >= 0 && v2[0].val + v2[1].val > mij) {
            update(1, 1, n, vin[v2[0].poz], -1);
            x = par[v2[0].poz];
            while (x != 0) {
                maxr = -INF;
                query(1, 1, n, vin[x] + 1, vout[x]);
                update(1, 1, n, vin[x], maxr + costp[x]);
                x = par[x];
            }
            k2--;
            i = 1;
            xp = v2[0].fiu;
            maxr = -INF;
            query(1, 1, n, vin[xp], vout[xp]);
            while (i < nrc && v2[i].val > maxr) {
                v2[i - 1].val = v2[i].val;
                v2[i - 1].poz = v2[i].poz;
                v2[i - 1].fiu = v2[i].fiu;
                i++;
            }
            v2[i - 1].val = maxr;
            v2[i - 1].fiu = xp;
            v2[i - 1].poz = maxp;
        }
    }
}
int main()
{
    //o cautare binara in care testez daca pot sa il fac <= mij
    //fixez lca
    //sortez drumurile fiilor pana in subarbore si imi doresc mereu sa scad maximul pana cand ajung cele mai mari 2 sa respecte diametrul
    //tin un aint cu suma pe un lnat maimx pana jos + suma parintelui(adc pe muchia catre el)
    //la grupa 2 tin ce noduri din subarbore mai sunt active, ca la fiecare tin distanta maxima pana jos pe un lant
    int i, x, y, c, st, dr;
    scanf("%d%d", &n, &k);
    for (i = 0; i < n - 1; i++) {
        scanf("%d%d%d", &x, &y, &c);
        adj[x].push_back(y);
        adj[y].push_back(x);
        cost[x].push_back(c);
        cost[y].push_back(c);
    }
    for (i = 2; i <= n; i++) {
        par[i] = -1;
    }
    par[1] = 0;
    rez = 0;
    dfs(1);
    build(1, 1, n);
    st = 0;
    dr = rez;
    while (dr - st > 1) {
        mij = (st + dr) / 2;
        //refac vectorii
        for (i = 1; i <= n; i++) {
            costp[i] = costp2[i];
            aint[i] = aint2[i];
        }
        for (; i < 4 * n; i++) {
            aint[i] = aint2[i];
        }
        k2 = k;
        dfs2(1);
        if (k2 >= 0) {
            dr = mij;
        } else {
            st = mij;
        }
    }
    printf("%d\n", dr);
    return 0;
}
