#include <bits/stdc++.h>

using namespace std;

// Game's gone
// cine da numere mari totusi
// cred ca iau 55-ul si plec la urmatoarea

const int MAXN = 200'000;

vector<pair<int, int>> g[MAXN + 1];
int dist[MAXN + 1];

int dfs(int node, int parent) {
  int maxnod = node;
  for(auto edge : g[node]) {
    if(edge.first != parent) {
      dist[edge.first] = edge.second + dist[node];
      int candidat = dfs(edge.first, node);
      if(dist[candidat] > dist[maxnod]) {
        maxnod = candidat;
      }
    }
  }
  return maxnod;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  
  int n, k;
  cin >> n >> k;
  for(int i = 1; i < n; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    g[u].push_back({v, w});
    g[v].push_back({u, w});
  }

  if(k <= 1) {
    int nod = dfs(1, 0);
    dist[nod] = 0;
    nod = dfs(nod, 0);
    cout << dist[nod] - k << "\n";
  } else {

  }
  return 0;
}