#include <bits/stdc++.h>

using namespace std;

// Game's gone
// cine da numere mari totusi

const int MAXN = 2'000;

vector<pair<int, int>> g[MAXN + 1];
int dist[MAXN + 1], dp[MAXN + 1][MAXN + 1][2], cnt[MAXN + 1], stop, dp2[MAXN + 1][MAXN + 1][2];

int dfs(int node, int parent) {
  int maxnod = node;
  for(auto edge : g[node]) {
    if(edge.first != parent) {
      dist[edge.first] = edge.second + dist[node];
      int candidat = dfs(edge.first, node);
      if(dist[candidat] > dist[maxnod]) {
        maxnod = candidat;
      }
    }
  }
  return maxnod;
}

// dp[node][i][j][0/1] = din primii i fii ai lui node dezactivezi j muchii, care este distanta maxima/suma celor doua distante maxime

void dfs2(int node, int parent) {
  int frunza = 1;
  cnt[node] = 0;
  for(auto edge : g[node]) {
    int son = edge.first;
    if(son != parent) {
      dfs2(son, node);
      cnt[node] += cnt[son] + 1;
      frunza = 0;
    }
  }

  if(frunza) {
    dp[node][0][0] = dp[node][0][1] = 0;
    return;
  }

  for(int i = 0; i <= cnt[node]; i++) {
    dp[node][i][0] = dp[node][i][1] = 1e9;
  }

  int panaacum = 0;
  for(auto edge : g[node]) {
    int son = edge.first;
    if(son != parent) {
      for(int i = 0; i <= panaacum; i++) {
        for(int j = 0; j <= cnt[son]; j++) {
          dp2[node][i + j + 1][0] = dp[node][i + j + 1][0];
          dp2[node][i + j + 1][1] = dp[node][i + j + 1][1];
          dp2[node][i + j][0] = dp[node][i + j][0];
          dp2[node][i + j][1] = dp[node][i + j][1];
        }
      }
      if(panaacum == 0) {
        for(int j = 0; j <= cnt[son]; j++) {
          dp[node][j][0] = min(dp[node][j][0], dp[son][j][0] + 1);

          dp[node][j + 1][0] = min(dp[node][j + 1][0], dp[son][j][0]);

          dp[node][j][1] = min(dp[node][j][1], dp[son][j][1]);

          dp[node][j + 1][1] = min(dp[node][j + 1][1], dp[son][j][1]);
        }
      } else {
        for(int i = 0; i <= panaacum; i++) {
          for(int j = 0; j <= cnt[son]; j++) {
            dp2[node][i + j][0] = min(dp2[node][i + j][0], max(dp[node][i][0], dp[son][j][0] + 1));
            
            dp2[node][i + j + 1][0] = min(dp2[node][i + j + 1][0], max(dp[node][i][0], dp[son][j + 1][0]));
            
            if(dp[node][i][0] > dp[son][j][0] + 1) {
              dp2[node][i + j][1] = min(dp2[node][i + j][1],
                                        max(dp[node][i][1], dp[node][i][0] + dp[son][j][0] + 1));
            } else {
              dp2[node][i + j][1] = min(dp2[node][i + j][1],
                                        max(dp[son][j][1], dp[son][j][0] + 1 + dp[node][i][0]));
            }

            if(dp[node][i][0] > dp[son][j][0]) {
              dp2[node][i + j + 1][1] = min(dp2[node][i + j + 1][1], 
                                        max(dp[node][i][1], dp[node][i][0] + dp[son][j][0]));
            } else {
              dp2[node][i + j + 1][1] = min(dp2[node][i + j + 1][1], 
                                        max(dp[son][j][1], dp[node][i][0] + dp[son][j][0]));
            }
          }
        }
      }
      for(int i = 0; i <= panaacum; i++) {
        for(int j = 0; j <= cnt[son]; j++) {
          dp[node][i + j + 1][0] = dp2[node][i + j + 1][0];
          dp[node][i + j + 1][1] = dp2[node][i + j + 1][1];
          dp[node][i + j][0] = dp2[node][i + j][0];
          dp[node][i + j][1] = dp2[node][i + j][1];
        }
      }
      panaacum += cnt[son] + 1;
    }
  }
  stop = panaacum;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  
  int n, k;
  cin >> n >> k;
  for(int i = 1; i < n; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    g[u].push_back({v, w});
    g[v].push_back({u, w});
  }

  if(k <= 1) {
    int nod = dfs(1, 0);
    dist[nod] = 0;
    nod = dfs(nod, 0);
    cout << dist[nod] - k << "\n";
  } else {
    dfs2(1, 0);
    int answer = 1e9;
    for(int i = 1; i <= stop && i <= k; i++) {
      answer = min(answer, dp[1][i][1]);
    }
    cout << answer << "\n";
  }
  return 0;
}