#include <iostream>
#include <algorithm>
#define in cin
#define out cout

using namespace std;
using ll = long long;
const ll oo = 1e18;

ll f[3001];

int main()
{
    int n, m; in >> n >> m;
    int v[n];
    for(int i = 0; i < n; i++) in >> v[i];
    sort(v + 0, v + n);
    for(int i = 0; i <= n; i++) f[i] = -1;

    f[0] = 1;
    for(int i = 1; i <= n; i++){
        if(f[i - 1] > oo / i) break;
        f[i] = f[i - 1] * i;
    }

    for(int _i = 0; _i < m; _i++){
        int l, r, k; in >> l >> r >> k;
        int p1 = lower_bound(v + 0, v + n, l) - (v + 0);
        int p2 = upper_bound(v + 0, v + n, r) - (v + 0);

        int clc = p2 - p1;

        //cout << "clc = " << clc << '\n';

        int xmin = -1;
        for(int x = 1; x < clc; x++){
            if(f[x] == -1 || f[clc - x] == -1) continue;
            //cout << "clc = " << clc << " x = " << x << "C = " << f[clc] / (f[x] * f[clc - x]) << '\n';
            if(k <= f[clc] / (f[x] * f[clc - x])){
                xmin = x;
                break;
            }
        }
        out << xmin << '\n';
    }

    return 0;
}
