#include <bits/stdc++.h>
#define in cin
#define out cout

using namespace std;
using ll = long long;
const ll oo = 1e18;
const ll B = 100; // baza nr mari
const ll nrcB = 2; // cate cifre are fiecare grupa

struct nr_mare{
    vector<ll> v;
};

nr_mare operator*( const nr_mare & a, const nr_mare & b ){
    nr_mare c;
    c.v.resize(a.v.size() + b.v.size() - 1);
    for(int i = 0; i < c.v.size(); i++) c.v[i] = 0;
    for(int i = 0; i < a.v.size(); i++){
        for(int j = 0; j < b.v.size(); j++){
            c.v[i + j] += a.v[i] * b.v[j];
        }
    }

    ll t = 0;
    for(int i = 0; i < c.v.size() || t > 0; i++){
        if(i < c.v.size()){
            t += c.v[i];
            c.v[i] = t % B;
            t /= B;
        }else{
            c.v.push_back(t % B);
            t /= B;
        }
    }

    return c;
}

nr_mare operator*( const nr_mare & a, const ll & b ){
    nr_mare c;
    int t = 0;
    for(int i = 0; i < a.v.size() || t > 0; i++){
        if(i < a.v.size()) t += a.v[i] * b;
        c.v.push_back(t % B);
        t /= B;
    }

    return c;
}

bool operator<=( const nr_mare & a, const nr_mare & b ){
    //if(a.v.size() != b.v.size()) return a.v.size() < b.v.size();
    int nrca = 0, nrcb = 0;
    for(int i = 0; i < a.v.size(); i++){
        if(i != a.v.size() - 1) nrca += 2;
        else if(a.v[i] > 10) nrca += 2;
        else nrca++;
    }
    for(int i = 0; i < b.v.size(); i++){
        if(i != b.v.size() - 1) nrcb += 2;
        else if(b.v[i] > 10) nrcb += 2;
        else nrcb++;
    }

    if(nrca != nrcb) return nrca < nrcb;

    for(int i = a.v.size() - 1; i >= 0; i--){
        if(a.v[i] != b.v[i]) return a.v[i] < b.v[i];
    }
    return true;
}

void print(nr_mare a){
    for(int i = a.v.size() - 1; i >= 0; i--){
        if(i != a.v.size() -1 && a.v[i] < 10) out << "0";
        cout << a.v[i];
    }
}

nr_mare f[3001];

int main()
{
    int n, m; in >> n >> m;
    int v[n];
    for(int i = 0; i < n; i++) in >> v[i];
    sort(v + 0, v + n);

    f[0].v = {1};
    for(ll i = 1; i <= n; i++){
        f[i] = f[i - 1] * i;
    }

    /*cout << "f[n] : ";
    for(int i = f[n].v.size() - 1; i >= 0; i--) cout << f[n].v[i];
    cout << '\n';*/

    for(int _i = 0; _i < m; _i++){
        ll l, r;
        nr_mare k; in >> l >> r;

        int p1 = lower_bound(v + 0, v + n, l) - (v + 0);
        int p2 = upper_bound(v + 0, v + n, r) - (v + 0);

        int clc = p2 - p1;

        string ss; in >> ss;
        int t = 0;
        for(int i = ss.size() - 1; i >= 0; i -= nrcB){
            t = 0;
            for(int j = max(0LL, i - nrcB + 1); j <= i; j++) t = t * 10 + ss[j] - '0';
            k.v.push_back(t);
        }

        if(clc == 0){
            out << "-1\n";
            continue;
        }

        //cout << "clc = " << clc << '\n';

        int xmin = -1;
        for(int x = 1; x <= clc; x++){
            if((f[x] * f[clc - x]) * k <= f[clc]){
                xmin = x;
                break;
            }
        }

        if(xmin > clc / 2){
            return 11;
        }

        out << xmin << '\n';
    }

    return 0;
}

/*
15 1
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
1 1 6435
*/
