#include <bits/stdc++.h>
#define in cin
#define out cout

using namespace std;
using ll = long long;
const ll B = 1000000000; // baza nr mari
const ll nrcB = 9; // cate cifre are fiecare grupa


ll nrcif(ll nr){
    int c = 0;
    while(nr){
        c++; nr /= 10;
    }
    return c;
}

struct nr_mare{
    vector<__int128> v;
};


ll nrc_mare(const nr_mare & a){
    int nrca = 0;
    for(int i = 0; i < a.v.size(); i++){
        if(i != a.v.size() - 1) nrca += nrcB;
        else nrca += nrcif(a.v[i]);
    }
    return nrca;
}

nr_mare operator*( const nr_mare & a, const nr_mare & b ){
    nr_mare c;
    c.v.resize(a.v.size() + b.v.size() - 1);
    for(int i = 0; i < c.v.size(); i++) c.v[i] = 0;
    for(int i = 0; i < a.v.size(); i++){
        for(int j = 0; j < b.v.size(); j++){
            c.v[i + j] += a.v[i] * b.v[j];
        }
    }

    ll t = 0;
    for(int i = 0; i < c.v.size() || t > 0; i++){
        if(i < c.v.size()){
            t += c.v[i];
            c.v[i] = t % B;
            t /= B;
        }else{
            c.v.push_back(t % B);
            t /= B;
        }
    }

    return c;
}

nr_mare operator*( const nr_mare & a, const ll & b ){
    nr_mare c;
    ll t = 0;
    for(int i = 0; i < a.v.size() || t > 0; i++){
        if(i < a.v.size()) t += a.v[i] * b;
        c.v.push_back(t % B);
        t /= B;
    }

    return c;
}

bool operator<=( const nr_mare & a, const nr_mare & b ){
    //if(a.v.size() != b.v.size()) return a.v.size() < b.v.size();
    int nrca = nrc_mare(a), nrcb = nrc_mare(b);

    if(nrca != nrcb) return nrca < nrcb;

    for(int i = a.v.size() - 1; i >= 0; i--){
        if(a.v[i] != b.v[i]) return a.v[i] < b.v[i];
    }
    return true;
}

/*void print(nr_mare a){
    for(int i = a.v.size() - 1; i >= 0; i--){
        if(i != a.v.size() -1 && a.v[i] < 10) out << "0";
        cout << a.v[i];
    }
}*/

nr_mare f[3001];

int main()
{
    int n, m; in >> n >> m;
    int v[n];
    for(int i = 0; i < n; i++) in >> v[i];
    sort(v + 0, v + n);

    f[0].v = {1};
    for(ll i = 1; i <= n; i++){
        f[i] = f[i - 1] * i;
    }

    /*cout << "f[n] : ";
    for(int i = f[n].v.size() - 1; i >= 0; i--) cout << f[n].v[i];
    cout << '\n';*/

    for(int _i = 0; _i < m; _i++){
        ll l, r;
        nr_mare k; in >> l >> r;

        int p1 = lower_bound(v + 0, v + n, l) - (v + 0);
        int p2 = upper_bound(v + 0, v + n, r) - (v + 0);

        int clc = p2 - p1;

        string ss; in >> ss;
        int t = 0;
        for(int i = ss.size() - 1; i >= 0; i -= nrcB){
            t = 0;
            for(int j = max(0LL, i - nrcB + 1); j <= i; j++) t = t * 10 + ss[j] - '0';
            k.v.push_back(t);
        }

        if(clc == 0){
            out << "-1\n";
            continue;
        }

        //cout << "clc = " << clc << '\n';

        int xmin = -1;
        int lb = 1, rb = max(1, clc / 2);
        while(lb <= rb){
            int x = (lb + rb) / 2;

            int nrc1 = nrc_mare(f[x]) + nrc_mare(f[clc - x]) + nrc_mare(k) - 2;

            //cout << "x = " << x << " nrc1 = " << nrc1 << " nrcf = " << nrc_mare(f[clc]) << '\n';

            if(nrc1 <= nrc_mare(f[clc]) && (f[x] * f[clc - x]) * k <= f[clc]){
                xmin = x;
                rb = x - 1;
            }else lb = x + 1;
        }
        out << xmin << '\n';
    }

    return 0;
}

/*
15 1
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
1 1 6435
*/
