#include <bits/stdc++.h>

using namespace std;

std::istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}
std::ostream& operator<< (std::ostream& out, __int128& n) {
    std::string digs="";
    bool negative=false;
    if (n<0) {
        negative=true;
        n*=(-1);
    }
    for (;;) {
        digs+=(n%10+'0');
        n/=10;
        if (n==0) break;
    }
    reverse(digs.begin(),digs.end());
    if (negative==true) out << "-";
    out << digs;
    return out;
}

#define MAX 100000
#define MAXN 3000

__int128 f[MAX + 1];
__int128 fact[MAXN + 1];

__int128 C( __int128 n, __int128 k ) {
    return fact[n] / ( fact[k] * fact[n - k] );
}

signed main() {
    __int128 n, k, i, x, m, l, r, cate, mini, j;

    cin >> n >> m;
    fact[0] = 1;
    for( i = 1; i <= n; i++ ) {
        cin >> x;
        f[x]++;
        fact[i] = fact[i - 1] * i;
    }

    for( i = 1; i <= MAX; i++ )
        f[i] += f[i - 1];

    for( i = 1; i <= m; i++ ) {
        cin >> l >> r >> k;
        if( k == 1 ) {
            if( f[r] - f[l - 1] >= k )
                cout << 1 << '\n';
            else
                cout << -1 << '\n';
        } else {
            cate = f[r] - f[l - 1];
            mini = MAXN + 1;
            for( j = 1; j <= cate; j++ )
                if( C( cate, j ) >= k ) {
                    mini = j;
                    break;
                }
            if( mini == MAXN + 1 )
                cout << -1 << '\n';
            else
                cout << mini << '\n';
        }
    }
    return 0;
}
