#include <iostream>
#define ll long long

using namespace std;

int n, m, f[100005], l, r; ll k;

ll fact(int x)
{
    ll r = 1;
    for (int i = 2; i <= x; i++)
        r *= i;
    return r;
}

ll combinari(int n, int k)
{
    if (k > n) return 0;
    return fact(n) / fact(n-k) / fact(k);
}

int main()
{
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        f[x]++;
    }
    for (int i = 1; i < 100005; i++)
    {
        f[i] += f[i-1];
    }
    for (int i = 0; i < m; i++)
    {
        cin >> l >> r >> k;
        int available = f[r];
        if (l) available -= f[l-1];
        int possible = available, size = 1;
        while (possible < k && size <= available)
        {
            size++;
            possible = combinari(available, size);
        }
        if (possible >= k)
            cout << size << "\n";
        else
            cout << "-1\n";
    }
}