#include <bits/stdc++.h>

#define ll long long
#define ull unsigned long long
#define pb(x) push_back(x)
#define ins(x) insert(x)
#define mp(x,y) make_pair(x,y)
#define fast_ios ios_base::sync_with_stdio(0); cin.tie(NULL); cout.tie(NULL);


using namespace std;
class frewick
{
private:
    int n;
    vector<int>aib;
    int ub ( int x )
    {return x&(-x);}
public:
    frewick(int n )
    {
        this->n=n;
        aib.resize(n+1);
    }
    void update(int poz , int val)
    {
        for ( int i = poz ; i <= n ; i += ub(i))
            aib[i] += val;
    }
    int query ( int poz )
    {
        int suma = 0;
        for ( int i = poz ; i >= 1 ; i -= ub(i) )
            suma += aib[i];
        return suma;
    }
};
ull fact[100005] ;
void precalculation ( )
{
    fact[1]=1;
    fact[0]=1;
    for ( int i = 2 ; i <= 100005; ++ i )
        fact[i] = fact[i-1]*i;
}
int main()
{
    fast_ios
    int n;
    int q ;
    precalculation();
    cin >> n >> q;
    frewick aib(100005) ;
    vector<int>v(n+1);
    for ( int i = 1 ; i <= n ;++ i )
    {
        cin >> v [i] ;
        aib.update(v[i],1);
    }
    for ( int i = 1 ; i <= q ; ++ i )
    {
        int st,dr;
        ull k ;
        cin >> st >> dr >> k ;
        int nr = aib.query(dr)-aib.query(st-1);

        if ( k <= nr )
        {
            cout << 1 << '\n';
            continue;
        }
        bool ok = false ;
        for ( int j = 2 ; j <=nr ; ++ j )
        {
            ull comb = fact[nr]/(fact[nr-j]*fact[j]);
            if ( comb >= k )
            {
                cout << j << '\n' ;
                ok = 1 ;
                break;
            }
        }
        if ( !ok )
            cout << -1  << '\n' ;
    }
    return 0;
}
