#include <bits/stdc++.h>

#define ll long long
#define ull unsigned long long
#define pb(x) push_back(x)
#define ins(x) insert(x)
#define mp(x,y) make_pair(x,y)
#define fast_ios ios_base::sync_with_stdio(0); cin.tie(NULL); cout.tie(NULL);


using namespace std;
priority_queue<pair<int,int>,vector<pair<int,int>>>pq;
int dijktra ( vector<vector<pair<int,int>>>graph , int n , int start )
{
vector<pair<int,int>>costs(n+1);
for ( int i = 1 ; i <= n ; ++ i )
    costs[i].first=INT_MAX;
costs[start].first=0;
priority_queue<pair<int,int>,vector<pair<int,int>>,greater<pair<int,int>>>coada;
coada.push(mp(0,start));
while(!coada.empty())
{
    int nod = coada.top().second;
    int cost = coada.top().first ;
    coada.pop();
    if ( cost > costs[nod].first )
        continue;
    for ( auto it : graph[nod] )
    {
        if ( costs[it.first].first > cost + it.second )
        {
            costs[it.first].first = cost + it.second ;
            costs[it.first].second = costs[nod].second ;
            coada.push(mp(costs[it.first].first,it.first));
        }
    }
}
int nr = 0 ;
int max1 = 0;
for ( int i = 1 ; i <= n ; ++ i ){
    pq.push(costs[i]);
    if ( max1 < costs[i].first )
    {
        max1 = costs[i].first ;
        nr = i ;
    }
    }
return nr ;
}

int main()
{
    fast_ios
    int n, k ;
    cin >> n >> k;
    vector<vector<pair<int,int>>>graph(n+1);
    for ( int i = 1 ;i <= n-1 ; ++ i )
    {
        int a , b , x ;
        cin >> a >> b >> x ;
        graph[a].pb(mp(b,x));
        graph[b].pb(mp(a,x));
    }
    int start = dijktra(graph,n,1);
    int www = dijktra(graph,n,start);
    if ( k == 1 )
    {
        int max1 =0 ;
        while(!pq.empty() && pq.top().second == pq.top().first )
        {
            max1 = max ( pq.top().second, max1);
            pq.pop();
        }
        if ( pq.empty() )
            cout << max1 ;
        else
            cout << max(max1,pq.top().first-1);
    }
    else
        cout << pq.top().first ;
    return 0;
}
