#include <bits/stdc++.h>
#define ull unsigned long long

using namespace std;

const int nmax=1e5;
ull n,m,k,l,r,sp[nmax+5],a[nmax+5],v[nmax+5],up[nmax+5];

unordered_map <int,int> mp;

void multiply(ull a[], ull n)
{
    int t=0;
    for (int i=1; i<=a[0]; ++i,t/=10 )
    {
        t+=a[i]*n;
        a[i]=t%10;
    }

    while ( t )
    {
        a[++a[0]]=t%10;
        t/=10;
    }
}

void divide(ull a[], ull n)
{
    ull r=0;
    for (int i=a[0]; i>=1; i-- )
    {
        r=r*10+a[i];
        a[i]=r/n;
        r%=n;
    }

    while ( a[a[0]]==0 && a[0]>1 )
        a[0]--;
}

ull comb(ull n, ull kk)
{
    up[0]=1,up[1]=1;

    for (int i=2; i<=n; ++i )
        multiply(up,i);

    for (int i=2; i<=kk; ++i )
        divide(up,i);

    for (int i=2; i<=n-kk; ++i )
        divide(up,i);
}

ull compare(ull a[], ull v[] )
{
    if ( a[0]>v[0] )
        return 1;

    if ( a[0]<v[0] )
        return -1;

    int i=a[0];
    while ( a[i]==v[i] && i>0 )
        i--;

    if ( a[i]>v[i] )
        return 1;

    if ( a[i]<v[i] )
        return 2;

    return 0;
}

void reset()
{
    for (int i=0; i<=v[0]; i++ )
        v[i]=0;

    for (int i=0; i<=up[0]; i++ )
        up[i]=0;
}

ull combnormala(ull n, ull k)
{
    ull up=1,down=1;
    for (ull i=1; i<=n; i++ )
        up*=1ULL*i;

    for (ull i=1; i<=k; i++ )
        down*=1ULL*i;

    for (ull i=1; i<=n-k; i++ )
        down*=1ULL*i;

    return up/down;
}

ull maketoint(string s)
{
    ull nr=0;
    for (ull i=0; i<s.size(); i++ )
        nr=1ULL*(nr*10+(s[i]-'0'));
    return nr;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m;

    ull maxi=INT_MIN;
    for (int i=1; i<=n; i++ )
    {
        cin >> a[i];
        maxi=max(maxi,a[i]);
        mp[a[i]]++;
    }

    for (int i=1; i<=nmax; i++ )
        sp[i]=sp[i-1]+mp[i];

    while ( m-- )
    {
        int l,r;

        reset();

        string k;

        cin >> l >> r >> k;

        if ( k=="1" )
        {
            int nr=sp[r]-sp[l-1];
            if ( nr>0 )
                cout << 1 << '\n';
            else cout << -1 << '\n';

            continue;
        }

        if ( n<=50 )
        {
            ull kk=maketoint(k);
            ull nr=sp[r]-sp[l-1];

            ull res=0;
            for (ull lg=1; lg<=nr; lg++ )
            {
                if ( combnormala(nr,lg)>=kk  )
                {
                    res=lg;
                    break;
                }
            }
            if ( res==0 )
                cout << -1 << '\n';
            else cout << res << '\n';
        }
        else
        {
            ull sz=k.size();
            // combinari de nr luate cate lg
            ull t=0;

            v[0]=sz;
            for (int i=sz-1; i>=0; i-- ) // are maxim 18 cifre, de cee nu intra in timp
                v[++t]=k[i]-'0';

            ull nr=sp[r]-sp[l-1];

            ull res=0;
            for (int lg=1; lg<=nr; lg++ )
            {
                comb(nr,lg);
                int ok=compare(up,v); // daca up>=v avem buchet

                if ( ok==1 || ok==0 )
                {
                    res=lg;
                    break;
                }
            }

            if ( res==0 )
                cout << -1 << '\n';
            else cout << res << '\n';
        }
    }

    /*v[0]=1,v[1]=9;
    multiply(v,3);
    for (int i=v[0]; i>=1; i-- )
        cout << v[i] << " ";*/
    /*v[0]=3,v[1]=9,v[2]=7,v[3]=5;
    divide(v,12);
    /*for (int i=v[0]; i>=1; i-- )
        cout << v[i] << " ";*/
    return 0;
}
/*7 3
3 4 1 1 6 1 2
1 3 1
1 4 1
1 5 1*/

