#include<bits/stdc++.h>
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

void precnik(vector<vector<pair<int,int>>> graf, int &nv, int tr, int g) {
    for (int i = 0 ; i < graf[g].size() ; i++) {
        precnik(graf, nv, tr + graf[g][i].second, graf[g][i].first ) ;
    }
    nv = max(nv,tr) ;
}

void pod (vector<vector<pair<int,int>>> graf, int g, int br, int &nv) {
    for (int i = 0 ; i < graf[g].size() ; i++) {
        pod(graf, graf[g][i].first, br+1, nv ) ;
    }
    nv = max(nv,br) ;
}

void k1(vector<vector<pair<int,int>>> graf, int &nv, int &nv2, int tr, int g) {
    for (int i = 0 ; i < graf[g].size() ; i++) {
        k1(graf, nv, nv2, tr + graf[g][i].second, graf[g][i].first ) ;
    }
    if (tr >= nv) {
        nv2 = nv ;
        nv = tr ;
    }
}

int main()
{
    speed();
    int n, k ;
    cin >> n >> k ;
    vector<vector<pair<int,int>>> graf(n) ;
    bool wi1 = false ;
    for (int i = 0 ; i < n - 1 ; i++) {
        int a, b, c ;
        cin >> a >> b >> c;
        if (a < b) {
            graf[a-1].push_back(make_pair(b-1,c)) ;
        }
        else {
            graf[b-1].push_back(make_pair(a-1,c)) ;
        }
        if (c == 1) {
            wi1 = true ;
        }
    }
    if (k == 1) {
        int nv = 0 ;
        int nv2 = 0 ;
        int tr = 0 ;
        int g = 0 ;
        k1(graf,nv,nv2,tr,g) ;
        if (nv == nv2) {
            cout << nv << endl ;
        }
        else {
            cout << nv - 1 << endl ;
        }
    }
    else if (k == 0) {
        int nv = 0 ;
        int tr = 0 ;
        int g = 0 ;
        precnik(graf,nv,tr,g) ;
        cout << nv << endl;
    }
    else if (wi1) {
        int br = 0 ;
        int g = 0 ;
        int nv = 0 ;
        pod(graf,g,br,nv) ;
        cout << nv << endl;
    }
}