#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<vector<pair<int, int>>> gr;

pair<ll, ll> dfsFindDim(int u, int p) {
    ll dim = 0;
    vector<ll> pths;
    for (auto [v, w] : gr[u]) {
        if (v != p) {
            auto [dm, pt] = dfsFindDim(v, u);
            pt += w;
            dim = max(dim, dm);
            pths.push_back(pt);
        }
    }
    sort(pths.rbegin(), pths.rend());
    pths.push_back(0);
    dim = max(dim, pths[0] + (pths.size() > 1 ? pths[1] : 0));
    return {dim, pths[0]};
}

ll big_dim;
ll num_dims = 0;
ll countDims(int u, int p) {
    vector<ll> pths;
    for (auto [v, w] : gr[u]) {
        if (v != p) {
            ll pt = countDims(v, u);
            pt += w;
            pths.push_back(pt);
        }
    }
    sort(pths.rbegin(), pths.rend());
    while (!pths.empty() && pths.back() == 0) {
        pths.pop_back();
    }
    if (pths.size() >= 2) {
        if (pths[0] + pths[1] == big_dim) {
            num_dims += 1;
            if (pths[2] == pths[1]) {
                num_dims++;
            }
        }
    } else if (pths.size() == 1) {
        if (pths[0] == big_dim) {
            num_dims++;
        }
    }
    return pths.empty() ? 0 : pths[0];
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    gr.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        gr[u - 1].emplace_back(v - 1, w);
        gr[v - 1].emplace_back(u - 1, w);
    }
    big_dim = dfsFindDim(0, -1).first;
    countDims(0, -1);
    cout << big_dim - (k == 1 && num_dims == 1) << "\n";
}