#include <bits/stdc++.h>

using namespace std;

using ll = long long;

string su(string a1, string b1) {
    string a = a1;
    string b = b1;
    int n = (int)a.size();
    int m = (int)b.size();
    ll vsp = 0;
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    string ans = "";
    for (int i = 0; i < max(n, m); i++) {
        ll v = vsp;
        if (i < n) {
            v += a[i] - '0';
        }
        if (i < m) {
            v += b[i] - '0';
        }
        ans += char('0' + v % 10);
        vsp = v / 10;
    }
    if (vsp) {
        ans += "1";
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

string perci(string s, ll k) {
    string an = s;
    while (k % 10 == 0) {
        an += "0";
        k /= 10;
    }
    reverse(an.begin(), an.end());
    ll vsp = 0;
    int n = (int)an.size();
    string ans = "";
    for (int i = 0; i < n; i++) {
        ll v = vsp;
        v += int(an[i] - '0') * k;
        ans += char('0' + v % 10);
        vsp = v / 10;
    }
    if (vsp) {
        ans += char('0' + vsp);
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

string per(string s, ll k) {
    ll vsp = 1;
    string ans = "";
    string s1 = s;
    reverse(s1.begin(), s1.end());
    while (k > 1) {
        ans = su(ans, perci(s1, (k % 10) * vsp));
        k /= 10;
        vsp *= 10;
    }
    //reverse(ans.begin(), ans.end());
    return ans;
}

string del(string s1, ll k) {
    ll cur = 0;
    string s = s1;
    //reverse(s.begin(), s.end());
    string ans = "";
    for (int i = 0; i < (int)s.size(); i++) {
        cur *= 10;
        cur += (s[i] - '0');
        if (ans.size() == 0 && cur < k) {
            continue;
        }
        ans += char('0' + cur / k);
        cur %= k;
    }
    return ans;
}

bool big(string bi, string sma) {
    if (bi.size() > sma.size()) {
        return 1;
    }
    if (bi.size() < sma.size()) {
        return 0;
    }
    for (int i = 0; i < (int)sma.size(); i++) {
        if (bi[i] > sma[i]) {
            return 1;
        }
        if (bi[i] < sma[i]) {
            return 0;
        }
    }
    return 1;
}

ll c(ll n, ll k) {
    ll ans = 1;
    for (int i = (n - k) + 1; i <= n; i++) {
        ans *=  i;
    }
    for (int i = 1; i <= k; i++) {
        ans /= i;
    }
    return ans;
}

signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ll n, t;
    cin >> n >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    while (t--) {
        ll l, r;
        cin >> l >> r;
        ll cnt = upper_bound(a.begin(), a.end(), r) - lower_bound(a.begin(), a.end(), l);
        ll v;
        cin >> v;
        ll r1 = cnt / 2;
        if (c(cnt, r1) >= v) {
            ll l1 = 0;
            while (r1 - l1 > 1) {
                ll m = (r1 + l1) / 2;
                if (c(cnt, m) >= v) {
                    r1 = m;
                } else {
                    l1 = m;
                }
            }
            cout << r1 << endl;
        } else {
            cout << -1 << endl;
        }
    }
}