#include <bits/stdc++.h>
using namespace std;
using ll = long long;


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
    }
    sort(a.begin(), a.end());

    //C[n][k]
    vector<vector<ll>> dp(n + 1, vector<ll> (n + 1));
    for (ll i = 0; i <= n; i++) {
        dp[i][0] = 1;
        dp[i][i] = 1;
    }
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j < i; j++) {
            dp[i][j] = (dp[i - 1][j] + dp[i - 1][j - 1]);
        }
    }

    vector<vector<ll>> rm(n + 1);
    for (ll i = 0; i <= n; i++) {
        for (ll j = 0; j <= n / 2; j++) {
            rm[i].push_back(dp[i][j]);
        }
    }

    while (q--) {
        ll l, r, k;
        cin >> l >> r >> k;
        ll cn = upper_bound(a.begin(), a.end(), r) - lower_bound(a.begin(), a.end(), l);
        ll id = lower_bound(rm[cn].begin(), rm[cn].end(), k) - rm[cn].begin();

        cout << (id == (ll)rm[cn].size() ? -1 : id) << '\n';
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}