#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INF = 1e18 + 7;


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
    }
    sort(a.begin(), a.end());

    //C[n][k]
    vector<vector<ll>> dp(n + 1, vector<ll> (n + 1));
    for (ll i = 0; i <= n; i++) {
        dp[i][0] = 1;
    }
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= i; j++) {
            if (dp[i - 1][j] == INF || dp[i - 1][j - 1] == INF) {
                dp[i][j] = INF;
                continue;
            }
            dp[i][j] = (dp[i - 1][j] + dp[i - 1][j - 1]);
            if (dp[i][j] >= INF) {
                dp[i][j] = INF;
            }
        }
    }

    vector<vector<ll>> rm(n + 1);
    for (ll i = 0; i <= n; i++) {
        for (ll j = 0; j <= i / 2; j++) {
            rm[i].push_back(dp[i][j]);
        }
    }

    while (q--) {
        ll l, r, k;
        cin >> l >> r >> k;
        ll cn = upper_bound(a.begin(), a.end(), r) - lower_bound(a.begin(), a.end(), l);
        if (k == 1) {
            cout << (cn > 0 ? 1 : -1) << '\n';
            continue;
        }

        ll rs = -1;
        for (ll i = 0; i <= cn / 2; i++) {
            if (rs == -1 && k <= dp[cn][i]) {
                rs = i;
            }
        }
        cout << rs << '\n';
        /*
        ll id = lower_bound(rm[cn].begin(), rm[cn].end(), k) - rm[cn].begin();

        cout << (id == (ll)rm[cn].size() ? -1 : id) << '\n';*/
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}