#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
//const ll INF = 1e18 + 7;
const ll MAXC = 301;

struct Int {
    vector<char> r;

    bool operator == (const Int &o) const {
        return (r == o.r);
    }

    bool operator <= (const Int &o) const {
        if (r.size() != o.r.size()) {
            return r.size() < o.r.size();
        }
        for (ll i = (ll)r.size() - 1; i >= 0; i--) {
            if (r[i] != o.r[i]) {
                return r[i] < o.r[i];
            }
        }
        return true;
    }

    bool operator >= (const Int &o) const {
        if (r.size() != o.r.size()) {
            return r.size() > o.r.size();
        }
        for (ll i = (ll)r.size() - 1; i >= 0; i--) {
            if (r[i] != o.r[i]) {
                return r[i] > o.r[i];
            }
        }
        return true;
    }

    bool operator < (const Int &o) const {
        if (r.size() != o.r.size()) {
            return r.size() < o.r.size();
        }
        for (ll i = (ll)r.size() - 1; i >= 0; i--) {
            if (r[i] != o.r[i]) {
                return r[i] < o.r[i];
            }
        }
        return false;
    }

    Int operator + (const Int &o) const {
        ll sz1 = r.size();
        ll sz2 = o.r.size();
        ll mx = max(sz1, sz2);

        ll car = 0;
        vector<char> ret(mx);
        for (ll i = 0; i < mx; i++) {
            ll w = car;
            if (i < sz1) w += (r[i] - '0');
            if (i < sz2) w += (o.r[i] - '0');
            ret[i] = char('0' + w % 10);
            car = w / 10;
        }
        if (car) {
            ret.push_back(char('0' + car));
        }

        return Int(ret);
    }

    Int(string _r) {
        r = {};
        reverse(_r.begin(), _r.end());
        for (auto &c : _r) {
            r.push_back(c);
        }
    }
    Int(const vector<char> &_r) {
        r = _r;
    }
    Int() {
        r = {'0'};
    }
};


void solve() {
    ll n, q;
    cin >> n >> q;
    //n = 3000;
    //q = 100000;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
        //el = 1;
    }
    sort(a.begin(), a.end());

    //cout << coco << '\n';
    vector<pair<ll, Int>> qs;
    vector<ll> rs;
    while (q--) {
        ll l, r;
        string kk;
        cin >> l >> r >> kk;
        //l = 1;
        //r = 1;
        //kk = "1021021092192012912910219292121";
        Int k = Int(kk);
        ll cn = upper_bound(a.begin(), a.end(), r) - lower_bound(a.begin(), a.end(), l);
        qs.push_back({cn, k});
        if (k == Int("1")) {
            rs.push_back(cn > 0 ? 1 : -1);
            continue;
        }
        if ((ll)kk.size() >= MAXC) {
            rs.push_back(-1);
            continue;
        }
        rs.push_back(-2);
    }

    vector<vector<ll>> ids(n + 1);
    for (ll i = 0; i < (ll)qs.size(); i++) {
        if (rs[i] != -2) continue;
        ids[qs[i].first].push_back(i);
    }

    vector<Int> dp(n + 2);
    dp[0] = Int("1");
    for (ll i = 0; i <= n; i++) {
        vector<Int> ww;
        for (ll j = 0; j <= i / 2; j++) {
            ww.push_back(dp[j]);
        }
        for (auto &id : ids[i]) {
            ll idd = lower_bound(ww.begin(), ww.end(), qs[id].second) - ww.begin();
            rs[id] = (idd == (ll)ww.size() ? -1 : idd);
        }

        auto pp = dp;
        dp.assign(n + 2, {});
        dp[0] = Int("1");
        for (ll j = 1; j <= i + 1; j++) {
            dp[j] = (pp[j] + pp[j - 1]);
        }
    }

    for (auto &el : rs) {
        cout << el << '\n';
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << endl;
    #endif
    //cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << endl;
}
