#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
const ll INF = 1e18 + 7;
const ll MAXC = 301;

ll n, c_o;
vector<ll> dp, go;
vector<vector<pii>> g;

void dfs(ll v, ll p, ll dd) {
    go[v] = dd;
    vector<ll> son;
    for (auto &[u, w] : g[v]) {
        if (u == p) continue;
        dfs(u, v, dd + w);
        son.push_back(u);
    }

    if (son.empty()) {
        return;
    }

    ll mx1 = 0;
    ll mx2 = 0;
    for (auto &u : son) {
        if (go[u] > mx1) {
            mx2 = mx1;
            mx1 = go[u];
        } else if (go[u] > mx2) {
            mx2 = go[u];
        }
    }
    dp[v] = mx1 + mx2 - 2 * go[v];

    for (auto &u : son) {
        go[v] = max(go[v], go[u]);
    }
}

void solve() {
    cin >> n >> c_o;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll v, u, w;
        cin >> v >> u >> w;
        --v; --u;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }

    go.assign(n, 0);
    dp.assign(n, 0);
    dfs(0, -1, 0);

    ll mx = 0;
    for (auto &el : dp) {
        mx = max(mx, el);
    }
    cout << mx << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}