#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INF = 1e18 + 7;
const ll MAXC = 301;

ll n, c_o, k;
vector<vector<ll>> g;
vector<vector<ll>> dp;

void dfs(ll v, ll p) {
    vector<ll> son;
    for (auto &u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        son.push_back(u);
    }

    if (son.empty()) {
        dp[v].assign(n, 0);
        return;
    }

    vector<ll> mn_s(n);
    for (auto &u : son) {
        for (ll d = 0; d < n; d++) {
            ll mn = dp[u][d] + 1;
            if (d) mn = min(mn, dp[u][d - 1]);
            mn_s[d] += mn;
        }
    }

    for (auto &u : son) {
        for (ll d = 0; d < min(n, k + 1); d++) {
            ll mn = dp[u][d] + 1;
            if (d) mn = min(mn, dp[u][d - 1]);
            ll cr = mn;

            ll sup = min(d, k - d);

            cr += mn_s[sup];
            ll ff = dp[u][sup] + 1;
            if (sup) ff = min(ff, dp[u][sup - 1]);
            cr -= ff;

            dp[v][d] = min(dp[v][d], cr);
        }
    }
}

void solve() {
    cin >> n >> c_o;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll v, u, w;
        cin >> v >> u >> w;
        --v; --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    ll lb = n;
    ll rb = -1;
    while (lb - rb > 1) {
        ll md = (lb + rb) / 2;
        dp.assign(n, vector<ll> (n, INF));
        k = md; dfs(0, -1);

        ll mn = INF;
        for (auto &el : dp[0]) {
            mn = min(mn, el);
        }
        if (mn <= c_o) {
            lb = md;
        } else {
            rb = md;
        }
    }

    cout << lb << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}
