#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
mt19937 rnd('S' + 'E' + 'E' + 'D');
const ll INF = 1e18 + 7;
const ll MAXC = 301;

ll n, c_o;
vector<ll> dd;
vector<vector<pii>> g;

void dfs(ll v, ll par, ll _d) {
    dd[v] = _d;
    for (auto &[u, w] : g[v]) {
        if (u != par) {
            dfs(u, v, _d + w);
        }
    }
}

pii diam() {
    vector<ll> ord(n);
    iota(ord.begin(), ord.end(), 0);
    shuffle(ord.begin(), ord.end(), rnd);
    dd.assign(n, 0);
    dfs(0, -1, 0);

    ll v = 0;
    for (auto &i : ord) {
        if (dd[i] > dd[v]) {
            v = i;
        }
    }


    dd.assign(n, 0);
    dfs(v, -1, 0);

    ll u = 0;
    for (auto &i : ord) {
        if (dd[i] > dd[u]) {
            u = i;
        }
    }

    return {v, u};
}

void mod_e(ll v, ll u, ll dl) {
    for (auto &[i, w] : g[v]) {
        if (i == u) w += dl;
    }
    for (auto &[i, w] : g[u]) {
        if (i == v) w += dl;
    }
}

vector<ll> cr, p;
void rest(ll v, ll par, ll nd) {
    p.push_back(v);
    if (v == nd) cr = p;
    for (auto &[u, w] : g[v]) {
        if (u != par) {
            rest(u, v, nd);
        }
    }
    p.pop_back();
}

void solve() {
    cin >> n >> c_o;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll v, u, w;
        cin >> v >> u >> w;
        --v; --u;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }

    auto [v, u] = diam();
    p.clear();
    cr.clear();
    rest(v, -1, u);

    ll mn = dd[u];
    if (c_o) {
        for (ll i = 0; i < (ll)cr.size() - 1; i++) {
            mod_e(cr[i], cr[i + 1], -1);
            auto [v1, u1] = diam();
            mn = min(mn, dd[u1]);
            mod_e(cr[i], cr[i + 1], 1);
        }
    }

    cout << mn << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}
