#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
mt19937 rnd('S' + 'E' + 'E' + 'D');
const ll INF = 1e18 + 7;
const ll MAXC = 301;

int n, c_o;
vector<int> dd;
vector<vector<pii>> g;

void dfs(int v, int par, int _d) {
    dd[v] = _d;
    for (auto &[u, w] : g[v]) {
        if (u != par) {
            dfs(u, v, _d + w);
        }
    }
}

pii diam() {
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    //shuffle(ord.begin(), ord.end(), rnd);
    dd.assign(n, 0);
    dfs(0, -1, 0);

    int v = 0;
    for (auto &i : ord) {
        if (dd[i] > dd[v]) {
            v = i;
        }
    }


    dd.assign(n, 0);
    dfs(v, -1, 0);

    int u = 0;
    for (auto &i : ord) {
        if (dd[i] > dd[u]) {
            u = i;
        }
    }

    return {v, u};
}

void mod_e(int v, int u, int dl) {
    for (auto &[i, w] : g[v]) {
        if (i == u) w += dl;
    }
    for (auto &[i, w] : g[u]) {
        if (i == v) w += dl;
    }
}

vector<int> cr, p;
void rest(int v, int par, int nd) {
    p.push_back(v);
    if (v == nd) cr = p;
    for (auto &[u, w] : g[v]) {
        if (u != par) {
            rest(u, v, nd);
        }
    }
    p.pop_back();
}

void solve() {
    cin >> n >> c_o;
    //n = 1e4;
    //c_o = 1;
    g.assign(n, {});
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        --v; --u;
        //v = i;
        //u = i + 1;
        //w = 1;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }

    auto [v, u] = diam();
    p.clear();
    cr.clear();
    rest(v, -1, u);

    int mn = dd[u];
    if (c_o) {
        vector<pii> ws;
        for (int i = 0; i < (int)cr.size() - 1; i++) {
            ws.push_back({cr[i], cr[i + 1]});
        }
        shuffle(ws.begin(), ws.end(), rnd);
        int sz = ws.size();
        for (int i = 0; i < min(sz, 15); i++) {
            auto [v, u] = ws[i];
            mod_e(v, u, -1);
            auto [v1, u1] = diam();
            mn = min(mn, dd[u1]);
            mod_e(v, u, 1);
        }
        /*for (int i = sz - 1; i >= max(0int, sz - 1 - 15); i--) {
            auto [v, u] = ws[i];
            mod_e(v, u, -1);
            auto [v1, u1] = diam();
            mn = min(mn, dd[u1]);
            mod_e(v, u, 1);
        }*/
    }

    cout << mn << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << endl;
    #endif
}
