#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<functional>
#include<numeric>
#include "monopoly2.h"
using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmin(a, b) a = min(a, b)
#define chmax(a, b) a= max(a, b)
#define pii pair<int, int>
#define tiii tuple<int, int, int>
const int M = 1e18;

vector <pair <int, int> > find_connections(int n) {
	vector<pii> e;
	if (n == 1) return {};
	vector<int> p(n); iota(all(p), 1);
	int j = n - 1;
	while (e.size() < n - 1) {
		vector<int> p1 = p;
		int l = 0, r = j;
		while (l + 1 != r) {
			int m = (l + r) / 2;
			rotate(p1.begin() + j - m, p1.begin() + j, p1.begin() + j + 1);
			vector<bool> b = check(p1);
			if (b[j - m] == 1) {
				r = m;
			}
			else {
				l = m;
			}
			p1 = p;
		}
		e.push_back({ p[j - r], p[j] }); --j;
	}
	
	return e;
}

/*void solve() {
	
}

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
*/