#include <bits/stdc++.h>

using namespace std;
vector<vector<long long>> fact;
long long mod = 100000;
vector<long long> pr(vector<long long> a, vector<long long> b) {
    vector<long long> c(a.size() + b.size() + 1000, 0);
    for (long long i = 0; i < a.size(); ++i) {
        for (long long j = 0; j < b.size(); ++j) {
            c[i + j] += a[i] * b[j];
        }
    }
    for (long long i = 0; i < c.size() - 1; ++i) {
        c[i + 1] += c[i] / mod;
        c[i] %= mod;
    }
    while (c.back() == 0) {
        c.pop_back();
    }
    return c;
}
bool is_good(vector<long long> a, vector<long long> b) {
    if (a.size() > b.size()) return true;
    if (b.size() > a.size()) return false;
    long long i = a.size() - 1;
    while (i >= 0 && a[i] == b[i]) {
        i--;
    }
    if (i == -1) return true;
    return a[i] >= b[i];
}
long long binsearch (long long cnt, vector<long long> k) {
    long long l = 0, r = (cnt + 1) / 2;
    while (r - l > 1) {
        long long m = (l + r) / 2;
        if (is_good(fact[cnt], pr(pr(k, fact[m]), fact[cnt - m]))) {
            r = m;
        } else {
            l = m;
        }
    }
    if (is_good(fact[cnt], pr(pr(k, fact[r]), fact[cnt - r]))) {
        return r;
    }
    return -1;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    long long n, m;
    cin >> n >> m;
    vector<long long> a(n);
    for (long long i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    fact.resize(n + 1);
    fact[0] = {1};
    for (long long i = 1; i <= n; ++i) {
        fact[i] = pr(fact[i - 1], {i});
    }
    while (m--) {
        long long l, r;
        string k1;
        cin >> l >> r >> k1;
        vector<long long> k;
        reverse(k1.begin(), k1.end());
        while (k1.size() % 5 != 0) {
            k1.push_back('0');
        }
        for (int i = 0; i < k1.size(); i += 5) {
            k.push_back(k1[i] - '0' + 10 * (k1[i + 1] - '0') + 100 * (k1[i + 2] - '0') + 1000 * (k1[i + 3] - '0') + 10000 * (k1[i + 4] - '0'));
        }
        l = lower_bound(a.begin(), a.end(), l) - a.begin();
        r = upper_bound(a.begin(), a.end(), r) - a.begin();
        if (r == l) {
            cout << -1 << '\n';
            continue;
        }
        cout << binsearch(r - l, k) << '\n';
    }
}
