#include <bits/stdc++.h>

using namespace std;
vector<vector<int>> fact;
int mod = 10;
vector<int> pr(vector<int> a, vector<int> b) {
    vector<int> c(a.size() + b.size() + 1000, 0);
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < b.size(); ++j) {
            c[i + j] += a[i] * b[j];
        }
    }
    for (int i = 0; i < c.size() - 1; ++i) {
        c[i + 1] += c[i] / mod;
        c[i] %= mod;
    }
    while (c.back() == 0) {
        c.pop_back();
    }
    return c;
}
bool is_good(vector<int> a, vector<int> b) {
    if (a.size() > b.size()) return true;
    if (b.size() > a.size()) return false;
    int i = a.size() - 1;
    while (i >= 0 && a[i] == b[i]) {
        i--;
    }
    if (i == -1) return true;
    return a[i] >= b[i];
}
int binsearch (int cnt, vector<int> k) {
    int l = 0, r = (cnt + 1) / 2;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (is_good(fact[cnt], pr(pr(k, fact[m]), fact[cnt - m]))) {
            r = m;
        } else {
            l = m;
        }
    }
    if (is_good(fact[cnt], pr(pr(k, fact[r]), fact[cnt - r]))) {
        return r;
    }
    return -1;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    fact.resize(n + 1);
    fact[0] = {1};
    for (int i = 1; i <= n; ++i) {
        fact[i] = pr(fact[i - 1], {i});
    }
    while (m--) {
        int l, r;
        string k1;
        cin >> l >> r >> k1;
        vector<int> k;
        reverse(k1.begin(), k1.end());
        for (int i = 0; i < k1.size(); i += 1) {
            k.push_back(k1[i] - '0');
        }
        l = lower_bound(a.begin(), a.end(), l) - a.begin();
        r = upper_bound(a.begin(), a.end(), r) - a.begin();
        if (r == l) {
            cout << -1 << '\n';
            continue;
        }
        cout << binsearch(r - l, k) << '\n';
    }
}
