#include <bits/stdc++.h>

using namespace std;

bool tr(vector<vector<vector<short int>>>& B, int a, int b, string& c) {
    if (B[a][b].size() != c.size()) return B[a][b].size() > c.size();
    int n = B[a][b].size();
    for (int i = n - 1; i >= 0; --i) {
        if (B[a][b][i] != (c[i] - '0')) return B[a][b][i] > (c[i] - '0');
    }
    return true;
}

int main() {
    int n, m, MAXX = 1e6; cin >> n >> m;
    vector<int> a(n);
    vector<int> cnt(MAXX, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        cnt[a[i]]++;
    }
    for (int i = 1; i < MAXX; ++i) {
        cnt[i] += cnt[i - 1];
    }
    vector<vector<vector<short int>>> B(n + 1, vector<vector<short int>> (n + 1));
    for (int i = 0; i <= n; ++i) B[0][i].push_back(1);
    for (int sum = 1; sum <= 3 * n / 2 + 2; ++sum) {
        for (int a = 1; a <= min(n, sum); ++a) {
            int b = sum - a;
            if (b >= 1 && b * 2 <= a) {
                int q = B[b - 1][a - 1].size(), w = B[b][a - 1].size();
                if (b * 2 > a - 1) {
                    w = B[a - 1 - b][a - 1].size();
                    int delta = 0;
                    for (int i = 0; i < max(w, q); ++i) {
                        if (i < w) {
                            delta += B[a - 1 - b][a - 1][i];
                        }
                        if (i < q) {
                            delta += B[b - 1][a][i];
                        }
                        B[b][a].push_back(delta % 10);
                        delta /= 10;
                    }
                    if (delta > 0) B[b][a].push_back(delta % 10);
                } else {
                    int delta = 0;
                    for (int i = 0; i < max(w, q); ++i) {
                        if (i < w) {
                            delta += B[b][a - 1][i];
                        }
                        if (i < q) {
                            delta += B[b - 1][a][i];
                        }
                        B[b][a].push_back(delta % 10);
                        delta /= 10;
                    }
                    if (delta > 0) B[b][a].push_back(delta % 10);
                }
            }
        }
    }
    while (m--) {
        int l, r; cin >> l >> r;
        if (l > r) {
            cout << -1 << '\n';
            continue;
        }
        int num = cnt[r] - cnt[l - 1];
        string k; cin >> k;
        reverse(k.begin(), k.end());
        if (!tr(B, num / 2, num, k)) {
            cout << -1 << '\n';
            continue;
        }
        int left = 0, right = num / 2 + 1;
        while (left < right - 1) {
            int mid = (left + right) / 2;
            if (tr(B, mid, num, k)) {
                right = mid;
            } else {
                left = mid;
            }
        }
        cout << right << '\n';
    }
}
