#include <bits/stdc++.h>

using namespace std;

bool tr(vector<vector<vector<short int>>>& B, int a, int b, vector<short int>& c) {
    if (B[a][b].size() != c.size()) return B[a][b].size() > c.size();
    int n = B[a][b].size();
    for (int i = n - 1; i >= 0; --i) {
        if (B[a][b][i] != c[i]) return B[a][b][i] > c[i];
    }
    return true;
}

int main() {
    int n, m, MAXX = 1e6, we = 10000; cin >> n >> m;
    vector<int> a(n);
    vector<int> cnt(MAXX, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        cnt[a[i]]++;
    }
    for (int i = 1; i < MAXX; ++i) {
        cnt[i] += cnt[i - 1];
    }
    vector<vector<vector<short int>>> B(n + 1, vector<vector<short int>> (n + 1));
    vector<vector<bool>> used(n + 1, vector<bool> (n + 1, 0));
    for (int i = 0; i <= n; ++i) B[0][i].push_back(1);
    for (int sum = 1; sum <= n + n / 2; ++sum) {
        for (int a = 1; a <= min(n, sum); ++a) {
            int b = sum - a;
            if (b >= 1 && b * 2 <= a) {
                int q = B[b - 1][a - 1].size(), w = B[b][a - 1].size();
                if (b * 2 > a - 1) {
                    w = B[a - 1 - b][a - 1].size();
                    if (used[a - 1 - b][a - 1] == 1 || used[b - 1][a - 1] == 1) {
                        used[a][b] = 1;
                        continue;
                    }
                    int delta = 0;
                    for (int i = 0; i < max(w, q); ++i) {
                        if (i < w) {
                            delta += B[a - 1 - b][a - 1][i];
                        }
                        if (i < q) {
                            delta += B[b - 1][a - 1][i];
                        }
                        B[b][a].push_back(delta % we);
                        delta /= we;
                    }
                    if (delta > 0) B[b][a].push_back(delta % we);
                    if (B[b][a].size() >= 250) used[b][a] = 1;
                } else {
                    if (used[b][a - 1] == 1 || used[b - 1][a - 1] == 1) {
                        used[a][b] = 1;
                        continue;
                    }
                    int delta = 0;
                    for (int i = 0; i < max(w, q); ++i) {
                        if (i < w) {
                            delta += B[b][a - 1][i];
                        }
                        if (i < q) {
                            delta += B[b - 1][a - 1][i];
                        }
                        B[b][a].push_back(delta % we);
                        delta /= we;
                    }
                    if (delta > 0) B[b][a].push_back(delta % we);
                    if (B[b][a].size() >= 250) used[b][a] = 1;
                }
            }
        }
    }
    while (m--) {
        int l, r; cin >> l >> r;
        if (l > r) {
            cout << -1 << '\n';
            continue;
        }
        int num = cnt[r] - cnt[l - 1];
        string k1; cin >> k1;
        vector<short int> k;
        int ost = 0;
        for (int i = 0; i < k1.size(); ++i) {
            if (ost * 10 >= we) {
                k.push_back(ost);
                ost = 0;
            }
            ost = ost * 10 + (k1[i] - '0');
        }
        if (ost > 0) k.push_back(ost);
        reverse(k.begin(), k.end());
        if (!tr(B, num / 2, num, k)) {
            cout << -1 << '\n';
            continue;
        }
        int left = 0, right = num / 2 + 1;
        while (left < right - 1) {
            int mid = (left + right) / 2;
            if (tr(B, mid, num, k)) {
                right = mid;
            } else {
                left = mid;
            }
        }
        cout << right << '\n';
    }
}
