#include<algorithm>
#include<iostream>
#include<vector>
using namespace std;

vector<vector<long long>> all_C;

long long C(long long n, long long k) {
    //cout << n << " " << k << endl;
    if (all_C[n][k] != -1) {
        return all_C[n][k];
    }
    if (n == k || k == 0) {
        return all_C[n][k] = 1;
    }
    return all_C[n][k] = C(n - 1, k - 1) + C(n - 1, k);
}


int main() {
    long long n, m;
    cin >> n >> m;
    all_C.resize(n + 1, vector<long long> (n + 1, -1));
    vector<long long> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    sort(a.begin(), a.end());
    while (m--) {
        long long l, r, k;
        cin >> l >> r >> k;
        l = lower_bound(a.begin(), a.end(), l) - a.begin();
        r = upper_bound(a.begin(), a.end(), r) - a.begin() - 1;
        long long L = 0, R = (r - l + 1 + 1) / 2;
        while (R - L > 1) {
            long long mid = (L + R) / 2;
            if (C(r - l + 1, mid) >= k) {
                R = mid;
            } else {
                L = mid;
            }
        }
        if (C(r - l + 1, R) >= k) {
            cout << R << endl;
        } else {
            cout << -1 << endl;
        }
    }
}