#include <stdio.h>

const int MAX_N = 3'000;
const int MAX_NUM = 100'000;

using ll = long long;
int a[MAX_N];
int freq[MAX_NUM + 1];

int comb(int n, int k) {
  if(n < k) {
    return 0;
  }
  ll res = 1;
  for(int i = 1; i <= k; i++) {
    res = res * (n - k + i);
  }
  for(int i = 1; i <= k; i++) {
    res = res / i;
  }
  return res;
}

int main() {
  int n, m;
  scanf("%d%d", &n, &m);
  for(int i = 0; i < n; i++) {
    scanf("%d", &a[i]);
    freq[a[i]]++;
  }
  for(int i = 1; i <= MAX_NUM; i++) {
    freq[i] += freq[i - 1];
  }
  for(int i = 0; i < m; i++) {
    int l, r, k;
    scanf("%d%d%d", &l, &r, &k);
    int total = freq[r] - freq[l - 1];
    int st = 0;
    int max_cresc = (total + 1) / 2;
    int dr = max_cresc + 1;
    while(dr - st > 1) {
      int mij = (st + dr) / 2;
      if(comb(total, mij) >= k) {
        dr = mij;
      } else {
        st = mij;
      }
    }
    printf("%d\n", (dr == max_cresc + 1) ? -1 : dr);
  }

  return 0;
}