#include <iostream>
#include <algorithm>
#define endl '\n'
using namespace std;
long long a[4000];
string dp[110][110];
long long n,m,l,r;
string str(long long i) {
    string res = "";
    while(i) {
        res.push_back(i%10+'0');
        i/=10;
    }
    reverse(res.begin(), res.end());
    return res;
}
bool bigger(string a, string b) {
    if(a.size()==b.size()) return a>=b;
    return a.size()>b.size();
}
string mul(string a, long long b) {
    string res = "";
    reverse(a.begin(), a.end());
    long long naum = 0;
    for(long long i = 0; i < a.size(); i++) {
        res.push_back(((a[i]-'0')*b+naum)%10 + '0');
        naum = ((a[i]-'0')*b+naum)/10;
    }
    while(naum) {res.push_back('0'+(naum%10)); naum /= 10;}
    reverse(res.begin(), res.end());
    return res;
}
string div(string a, long long b) {
    long long d = 0, start = -1;
    string res = "";
    for(int i = 0; i < a.size(); i++) {
        d *= 10;
        d += a[i]-'0';
        if(d/b != 0 && start == -1) start = i;
        res.push_back(d/b + '0');
        d %= b;
    }
    if(start==-1) return "0";
    return res.substr(start, res.size()-start);
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for(long long i = 1; i <= n; i++) cin >> a[i];
    for(long long i = 1; i <= n; i++) {
        dp[i][1]=str(i);
        for(long long j = 2; j <= i; j++) {
            dp[i][j]=(div(mul(dp[i][j-1],(i-j+1)),j));
        }
    }
    for(long long i = 1; i <= m; i++) {
        string k; cin >> l >> r >> k;
        long long br = 0;
        for(long long j = 1; j <= n; j++) if(a[j]>=l && a[j]<=r) br++;

        bool f = 0;
        long long l = 1, r = br, mid, ans=-1;
        while(l<=r) {
            mid = (l+r)/2;
            if(bigger(dp[br][mid],k)) {
                r = mid-1;
                ans = mid;
            }
            else {
                l = mid+1;
            }
        }
        cout << ans << endl;
    }
}