#include <iostream>
#include <algorithm>
#include <vector>
#define endl '\n'
using namespace std;
int a[4000];
string fact[4000];
int n,m,l,r;
bool bigger(string a, string b) {
    if(a.size()==b.size()) return a>=b;
    return a.size()>b.size();
}
string mul(string a, int b) {
    string res = "";
    reverse(a.begin(), a.end());
    int naum = 0;
    for(int i = 0; i < a.size(); i++) {
        res.push_back(((a[i]-'0')*b+naum)%10 + '0');
        naum = ((a[i]-'0')*b+naum)/10;
    }
    while(naum) {res.push_back('0'+(naum%10)); naum /= 10;}
    reverse(res.begin(), res.end());
    return res;
}
string sub(string a, string b) {
    string res = "";
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    while(a.size()<b.size()) a.push_back('0');
    while(b.size()<a.size()) b.push_back('0');
    int naum = 0;
    for(int i = 0; i < a.size(); i++) {
        int r = (a[i]-'0')-(b[i]-'0')-naum;
        if(r<0) {
            naum = 1;
            r += 10;
        }
        else naum = 0;
        res.push_back(r+'0');
    }
    while(res.back()=='0') res.pop_back();
    reverse(res.begin(), res.end());
    return res;
}
string div(string a, string b) {
    vector<string> mult;
    mult.push_back("0");
    for(int i = 1; i <= 9; i++) {mult.push_back(mul(b, i));}
    string d = "";
    string res = "";
    for(int i = 0; i < a.size(); i++) {
        d.push_back(a[i]);
        if(bigger(d, b)) {
            //cout << d << endl;
            int q = 9;
            for(int j = 1; j <= 9; j++) {
                if(bigger(mult[j], d)) {
                    q = j-1;
                    break;
                }
            }
            res.push_back(q + '0');
            d = sub(d, mult[q]);
        }
        else res.push_back('0');
    }
    for(int i = 0; i < res.size(); i++) {
        if(res[i]!='0') return res.substr(i, res.size()-i);
    }
    return "0";
}
string choose(int a, int b) {
    return div(div(fact[a], fact[a-b]), fact[b]);
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 1; i <= n; i++) cin >> a[i];
    
    fact[1]="1";
    for(int i = 2; i <= n; i++) {
        fact[i]=mul(fact[i-1], i);
    }

    for(int i = 1; i <= m; i++) {
        string k; cin >> l >> r >> k;
        int br = 0;
        for(int j = 1; j <= n; j++) if(a[j]>=l && a[j]<=r) br++;
        bool f = 0;
        int l = 1, r = br, mid, ans=-1;
        while(l<=r) {
            mid = (l+r)/2;
            string r = div(div(fact[n],fact[n-mid]), fact[mid]);
            if(bigger(r,k)) {
                r = mid-1;
                ans = mid;
            }
            else {
                l = mid+1;
            }
        }
        cout << ans << endl;
    }
}