#include <bits/stdc++.h>
using namespace std;

const int MAXN=3000;
const int MAXP=65;

long long a[MAXN];
long long paskal[MAXP][MAXP];

long long n, m;

long long bin(long long x)
{
    long long l=0;
    long long r=n+1;
    while(l<r)
    {
        long long m=(l+r)/2;
        if(a[m]>x)
        {
            r=m-1;
        }
        if(a[m]<x)
        {
            l=m+1;
        }
        if(a[m]==x)
        {
            return m;
        }
    }
    if(l>n-1)
    {
        return n-1;
    }
    return l;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void input()
{
    cin >> n >> m;
    for(long long i=0; i<n; i++)
    {
        cin >> a[i];
    }
}

void solve()
{
    sort(a, a+n);
    for(long long i=0; i<MAXP; i++)
    {
        for(long long j=0; j<i+1; j++)
        {
            if(j==0 || j==i)
            {
                paskal[i][j]=1;
                continue;
            }
            paskal[i][j]=paskal[i-1][j-1]+paskal[i-1][j];
        }
    }
    for(long long q=0; q<m; q++)
    {
        long long l, r, k;
        cin >> l >> r >> k;
        long long c=bin(l);
        for(long long i=c; i>=0; i--)
        {
            if(a[i-1]!=a[c])
            {
                c=i;
                break;
            }
        }
        long long g=bin(r);
        for(long long i=g; i<n; i++)
        {
            if(a[i+1]!=a[c])
            {
                g=i;
                break;
            }
        }
        bool b=1;
        for(long long i=1; i<g-c+1; i++)
        {
            if(paskal[g-c+1][i]>=k)
            {
                cout << i << endl;
                b=0;
                break;
            }
        }
        if(b)
        {
            cout << -1 << endl;
        }
    }
}

int main ()
{
    fastIO();
    input();
    solve();
    return 0;
}
