#include <bits/stdc++.h>
using namespace std;

const int MAXN=3000;
const int MAXP=100;

long long a[MAXN];
string paskal[MAXP][MAXP];

long long n, m;

string sum(string s1, string s2)
{
    int prenos=0;
    string ans;
    reverse(s1.begin(), s1.end());
    reverse(s2.begin(), s2.end());
    for(int i=0; i<max(s1.size(), s2.size()); i++)
    {
        if(i<min(s1.size(), s2.size()))
        {
            int s=s1[i]-'0'+s2[i]-'0'+prenos;
            ans.push_back(s%10+'0');
            prenos=s/10;
        }
        else
        {
            if(i>=s1.size())
            {
                int s=s2[i]-'0'+prenos;
                ans.push_back(s%10+'0');
                prenos=s/10;
            }
            else
            {
                int s=s1[i]-'0'+prenos;
                ans.push_back(s%10+'0');
                prenos=s/10;
            }
        }
    }
    if(prenos!=0)
    {
        ans.push_back(prenos+'0');
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

bool pogolqmoiliravno(string s1, string s2)
{
    if(s1.size()>s2.size())
    {
        return true;
    }
    if(s1.size()<s2.size())
    {
        return false;
    }
    for(int i=s1.size()-1; i>=0; i--)
    {
        if(s1[i]<s2[i])
        {
            return false;
        }
    }
    return true;
}

long long bin(long long x)
{
    long long l=0;
    long long r=n+1;
    while(l<r)
    {
        long long m=(l+r)/2;
        if(a[m]>x)
        {
            r=m-1;
        }
        if(a[m]<x)
        {
            l=m+1;
        }
        if(a[m]==x)
        {
            return m;
        }
    }
    if(l>n-1)
    {
        return n-1;
    }
    return l;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void input()
{
    cin >> n >> m;
    for(long long i=0; i<n; i++)
    {
        cin >> a[i];
    }
}

void solve()
{
    sort(a, a+n);
    for(long long i=0; i<MAXP; i++)
    {
        for(long long j=0; j<i+1; j++)
        {
            if(j==0 || j==i)
            {
                paskal[i][j]="1";
                continue;
            }
            paskal[i][j]=sum(paskal[i-1][j-1], paskal[i-1][j]);
        }
    }
    for(long long q=0; q<m; q++)
    {
        long long l, r;
        string k;
        cin >> l >> r >> k;
        long long c=bin(l);
        for(long long i=c; i>=0; i--)
        {
            if(a[i-1]!=a[c])
            {
                c=i;
                break;
            }
        }
        long long g=bin(r);
        for(long long i=g; i<n; i++)
        {
            if(a[i+1]!=a[c])
            {
                g=i;
                break;
            }
        }
        bool b=1;
        for(long long i=0; i<g-c+1; i++)
        {
            if(pogolqmoiliravno(paskal[g-c+1][i], k))
            {
                if(i==0)
                {
                    b=1;
                    break;
                }
                cout << i << endl;
                b=0;
                break;
            }
        }
        if(b)
        {
            cout << -1 << endl;
        }
    }
}

int main ()
{
    fastIO();
    input();
    solve();
    return 0;
}
