#include <bits/stdc++.h>
using namespace std;
#define MAXN 100000
int pascal[500][500];
vector<int> a;
struct Order
{
    int L;
    int R;
    int K;
};
int solve(Order o, int N)
{
    int ans=0;
    vector<int> posibilities={};
    for(int i=0;i<N;i++)
    {
        if(a[i]>=o.L && a[i]<=o.R)
        {
            posibilities.push_back(a[i]);
        }
    }
    int n=posibilities.size(), maxBouqetCnt=0, minBouqetSize=INT_MAX;
    int NumberOfPossibleBouqets[n], BouqetSizes[n];
    for(int k=1;k<=n;k++) ///k e размера на букета, n са наличните цветя
    {
        NumberOfPossibleBouqets[k] = pascal[n][k];
        BouqetSizes[k]=k;
        if(NumberOfPossibleBouqets[k]>maxBouqetCnt) maxBouqetCnt=NumberOfPossibleBouqets[k];
        if(BouqetSizes[k]<minBouqetSize) minBouqetSize=BouqetSizes[k];
    }
    if(maxBouqetCnt < o.K) return -1;
    ans=minBouqetSize; ///Отговорът е минималния брой цветя на букет
    return ans;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for(int i=0;i<250;i++)
    {
        pascal[i][0]=1;
        pascal[i][i]=1;
    }
    for(int i=1;i<250;i++)  ///Построяваме Паскал, за да може бързо да намираме комбинации
    {
        for(int j=1;j<250;j++)
        {
            pascal[i][j]=pascal[i-1][j]+pascal[i-1][j-1];
        }
    }

    int M,N;
    cin >> N >> M;
    a.resize(N);
    Order O[M];
    for(int i=0;i<N;i++)
    {
        cin >> a[i];
    }
    sort(a.begin(),a.end());
    for(int i=0;i<M;i++)
    {
        cin >> O[i].L >> O[i].R >> O[i].K;
        cout << solve(O[i], N) << endl;
    }
}
