#include <bits/stdc++.h>
using namespace std;
#define MAXN 100000
long long pascal[1000][1000];
vector<long long> a;
struct Order
{
    long long L;
    long long R;
    long long K;
};
long long solve(Order o, long long N)
{
    long long ans=0;
    vector<long long> posibilities={};
    for(long long i=0;i<N;i++)
    {
        if(a[i]>=o.L && a[i]<=o.R)
        {
            posibilities.push_back(a[i]);
        }
    }
    long long n=posibilities.size(), maxBouqetCnt=0, minBouqetSize=LLONG_MAX;
    long long NumberOfPossibleBouqets[n], BouqetSizes[n];
    for(long long k=1;k<=n;k++) ///k e размера на букета, n са наличните цветя
    {
        NumberOfPossibleBouqets[k] = pascal[n][k];
        BouqetSizes[k]=k;
        if(NumberOfPossibleBouqets[k]>maxBouqetCnt) maxBouqetCnt=NumberOfPossibleBouqets[k];
        if(BouqetSizes[k]<minBouqetSize && NumberOfPossibleBouqets[k]>=o.K) minBouqetSize=BouqetSizes[k];
    }
    if(maxBouqetCnt < o.K) return -1;
    ans=minBouqetSize; ///Отговорът е минималния брой цветя на букет
    return ans;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for(long long i=0;i<1000;i++)
    {
        pascal[i][0]=1;
        pascal[i][i]=1;
    }
    for(long long i=1;i<1000;i++)  ///Построяваме Паскал, за да може бързо да намираме комбинации
    {
        for(long long j=1;j<1000;j++)
        {
            pascal[i][j]=pascal[i-1][j]+pascal[i-1][j-1];
        }
    }

    long long M,N;
    cin >> N >> M;
    a.resize(N);
    Order O[M];
    for(long long i=0;i<N;i++)
    {
        cin >> a[i];
    }
    sort(a.begin(),a.end());
    for(long long i=0;i<M;i++)
    {
        cin >> O[i].L >> O[i].R >> O[i].K;
        cout << solve(O[i], N) << endl;
    }
    return 0;
}
