#include <bits/stdc++.h>
#define PII pair<int,int>
#define to first
#define teglo second
using namespace std;
vector<PII> graph[1024]; ///Вектор от pair<int,int>, който пази ребрата като индекса е върха, .first е дестинацията, а .second е теглото
vector<bool> used; ///Вектор, осигуряващ това да не е възможно връщане назад по пътища
vector <int> dist; ///Вектор, пазещ най дългите пътища, започващи от даден връх
//priority_queue<PII, vector<PII>, greater<PII>> pq;
int maxDist=-1; ///Променлива, с която намиламе максималния път
void MitFS(int u, int distance) ///Писнало Ви е от стари и работещи алгоритми като BFS и DFS?
{                               ///Иммено затова сътворих нов алгоритъм на име MitFS, който не само
                                ///трябва да намира най-дълъг път, а и дава RE. Точно това, което всеки търси
    //cout << "Distance to " << u << " is " << distance << endl;
    if(distance>maxDist) maxDist=distance;
    //pq.push({u,distance});
    used[u] = true;
    for(PII v:graph[u])
    {
        if(used[v.to]==false)
        {
            MitFS(v.to, (v.teglo+distance)); ///Стигаме до дъното, малко като DFS, но все пак сме оригинални, защото ползваме PII
        }
    }
}
int findDiameter(int u)
{
    dist.resize(graph[u].size());
    used[u]=true;
    for(PII v:graph[u]) ///Обхождаме съседите
    {
        maxDist=0; ///За всеки съсед, нулираме
        MitFS(v.to,v.teglo); ///Намираме най дългия път, започващ от съседа
        dist.push_back(maxDist); ///Пазим разстоунието до него
        //cout << "The longest path from " << v.to << " is " << maxDist << endl;
    }
    sort(dist.rbegin(),dist.rend()); ///Сортираме във низходящ ред
    //cout << "The longest 2 subtrees are " << dist[0] << " and " << dist[1] << endl;
    int ans=dist[0]+dist[1]; ///Най-дългия път обикновено представлява сбор от двапътя, започващи от u
    return ans;
}
int main()
{
    ios_base::sync_with_stdio(false);   ///Да сме бързи, нищо, че самата програма не работи
    cin.tie(0);
    cout.tie(0);

    int n,k,beg=1,x;
    cin >> n >> k;
    //graph.resize(n);
    used.resize(n);
    for(int i=0;i<n-1;i++)
    {
        int u,v,w;
        cin >> u >> v >> w;
        x=u;
        graph[u].push_back({v,w});
        graph[v].push_back({u,w});
    }
    cout << findDiameter(x) << endl;
}
