#include<bits/stdc++.h>
using namespace std;

const int MAXN = 3007;
int n, m, l, r, a[MAXN];
int k, pascal[MAXN][MAXN];

int bs1(int x)
{
    int l = 0, r = n+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(a[mid] < x) l = mid;
        else r = mid;
    }
    return r;
}

int bs2(int x)
{
    int l = 0, r = n+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(a[mid] > x) r = mid;
        else l = mid;
    }
    return l;
}

int bs3(int i, int x)
{
    int l = -1, r = i/2+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(pascal[i][mid] < x) l = mid;
        else r = mid;
    }
    return r;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    for(int i = 0; i <= n; i++)
    {
        for(int j = 0; j <= n; j++)
        {
            pascal[i][j] = 0;
        }
    }
    pascal[0][0] = 1;
    for(int i = 1; i <= n; i++)
    {
        pascal[i][0] = 1;
        for(int j = 1; j < i; j++)
        {
            pascal[i][j] = pascal[i-1][j]+pascal[i-1][j-1];
        }
        pascal[i][i] = 1;
    }
    for(int i = 1; i <= n; i++)
    {
        cin>>a[i];
    }
    sort(a+1, a+n+1);
    for(int zz = 0; zz < m; zz++)
    {
        cin>>l>>r>>k;
        int ll = bs1(l);
        int rr = bs2(r);
        int len = rr-ll+1;
        if(pascal[len][len/2]<k)
        {
            cout<<"-1\n";
            continue;
        }
        int ans = bs3(len, k);
        cout<<ans<<"\n";
    }
    return 0;
}

