#include<bits/stdc++.h>
using namespace std;

const long long MAXN = 3007, MAXK = 907;
long long n, m, l, r, a[MAXN];
string k;
vector<string> pascal[MAXN];

void sum(long long ai, long long aj)
{
    string a = pascal[ai-1][aj-1];
    string b = pascal[ai-1][aj];
    if(a.size() > b.size()) swap(a, b);
    while(a.size() < b.size()) a += '0';
    a += '0';
    b += '0';
    long long prenos = 0;
    string c;
    for(long long i = 0; i < a.size() || prenos != 0; i++)
    {
        long long ans = (a[i]-'0')+(b[i]-'0')+prenos;
        prenos = ans/10;
        ans %= 10;
        c += ans+'0';
    }
    while(a.back() == '0') a.pop_back();
    while(b.back() == '0') b.pop_back();
    while(c.back() == '0') c.pop_back();
    pascal[ai].push_back(c);
    return;
}

bool smaller(string& a, string& b)
{
    if(a.size() > b.size()) return false;
    if(a.size() < b.size()) return true;
    for(long long i = 0; i < a.size(); i++)
    {
        if(a[i] > b[i]) return false;
        if(a[i] < b[i]) return true;
    }
    return false;
}

long long bs1(long long x)
{
    long long l = 0, r = n+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(a[mid] < x) l = mid;
        else r = mid;
    }
    return r;
}

long long bs2(long long x)
{
    long long l = 0, r = n+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(a[mid] > x) r = mid;
        else l = mid;
    }
    return l;
}

long long bs3(long long i, string& x)
{
    long long l = 0, r = i/2+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(smaller(pascal[i][mid], x)) l = mid;
        else r = mid;
    }
    return r;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    pascal[0].push_back("1");
    for(long long i = 1; i <= n; i++)
    {
        pascal[i].push_back("1");
        for(long long j = 1; j < i; j++)
        {
            sum(i, j);
        }
        pascal[i].push_back("1");
    }
    for(long long i = 1; i <= n; i++)
    {
        cin>>a[i];
    }
    sort(a+1, a+n+1);
    for(long long zz = 0; zz < m; zz++)
    {
        cin>>l>>r>>k;
        reverse(k.begin(), k.end());
        long long ll = bs1(l);
        long long rr = bs2(r);
        long long len = rr-ll+1;
        if(len <= 0 || smaller(pascal[len][len/2], k))
        {
            cout<<-1<<"\n";
            continue;
        }
        if(k == "1")
        {
            cout<<1<<"\n";
            continue;
        }
        long long ans = bs3(len, k);
        cout<<ans<<"\n";
    }
    return 0;
}
