#include<bits/stdc++.h>
using namespace std;

const long long MAXN = 3007;
long long n, m, l, r, a[MAXN];
long long k, pascal[MAXN][MAXN];

long long bs1(long long x)
{
    long long l = 0, r = n+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(a[mid] < x) l = mid;
        else r = mid;
    }
    return r;
}

long long bs2(long long x)
{
    long long l = 0, r = n+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(a[mid] > x) r = mid;
        else l = mid;
    }
    return l;
}

long long bs3(long long i, long long x)
{
    long long l = 0, r = i/2+1, mid;
    while(l < r-1)
    {
        mid = (l+r)/2;
        if(pascal[i][mid] < x) l = mid;
        else r = mid;
    }
    return r;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    pascal[0][0] = 1;
    for(long long i = 1; i <= n; i++)
    {
        pascal[i][0] = 1;
        for(long long j = 1; j < i; j++)
        {
            pascal[i][j] = pascal[i-1][j]+pascal[i-1][j-1];
        }
        pascal[i][i] = 1;
    }
    for(long long i = 1; i <= n; i++)
    {
        cin>>a[i];
    }
    sort(a+1, a+n+1);
    for(long long zz = 0; zz < m; zz++)
    {
        cin>>l>>r>>k;
        long long ll = bs1(l);
        long long rr = bs2(r);
        long long len = rr-ll+1;
        if(len <= 0 || pascal[len][len/2] < k)
        {
            cout<<-1<<"\n";
            continue;
        }
        if(k == 1)
        {
            cout<<1<<"\n";
            continue;
        }
        long long ans = bs3(len, k);
        cout<<ans<<"\n";
    }
    return 0;
}

