#include<bits/stdc++.h>
using namespace std;

const int MAXN = 2*1e5+7;
int n, k, depth[MAXN];
bool vis[MAXN];
vector<pair<int, int> > adj[MAXN];

void dfs(int x)
{
    vis[x] = true;
    for(pair<int, int> next: adj[x])
    {
        if(vis[next.second]) continue;
        depth[next.second] = depth[x]+next.first;
        //cout<<next.second<<" "<<depth[next.second]<<"\n";
        dfs(next.second);
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    int sum = 0;
    for(int i = 1; i < n; i++)
    {
        int a, b, c;
        cin>>a>>b>>c;
        adj[a].push_back({c, b});
        adj[b].push_back({c, a});
        sum += c;
    }
    dfs(1);
    int maxi = 0, maxii = -1;
    for(int i = 1; i <= n; i++)
    {
        if(depth[i] > maxi)
        {
            maxi = depth[i];
            maxii = i;
        }
        depth[i] = 0;
        vis[i] = false;
    }
    dfs(maxii);
    maxi = 0;
    for(int i = 1; i <= n; i++)
    {
        maxi = max(maxi, depth[i]);
    }
    if(k == 0) cout<<maxi;
    else cout<<maxi-1;
    return 0;
}
