#include <iostream>
#include <bits/stdc++.h>
using namespace std;
int n, m;
long long a[3005];
void read()
{
    cin >> n >> m;
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    sort(a+1, a+n+1);
}
int bin_search1(long long x)
{
    int l = 1, r = n;
    while(l <= r)
    {
        int mid = (l+r)/2;
        if(a[mid] >= x)r = mid-1;
        else l = mid+1;
    }
    return l;
}
long long fact[64];
void fill_fact()
{
    fact[0] = 1;
    for(int i = 1; i <= n; i++)
    {
        fact[i] = fact[i-1]* i;
    }
}
long long bin_search(int x, long long k)
{
    long long l = 1, r = x;
    while(l <= r)
    {
        int mid = (l+r)/2;
        if(fact[x]/(fact[mid]*fact[x-mid]) >= k)r = mid-1;
        else l = mid+1;
    }
    return l;
}
void solve()
{
    int l, r;
    long long k;
    for(int i = 1; i <= m; i++)
    {
        cin >> l >> r >> k;
        int l1 = bin_search1(l);
        int r1 = bin_search1(r);
        if(a[r1] == r)r1++;
        if(k == 1 && r1>l1)cout << 1 << endl;
        else if(r1 <= l1)cout << -1 << endl;
        else
        {
            long long ans =  bin_search(r1-l1, k);
        if(ans > r1-l1)ans = -1;
        cout << ans << endl;
        }

    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    fill_fact();
    solve();
    return 0;
}
