#include <bits/stdc++.h>

using namespace std;

long long dp[101];

long long permutations(int q)
{
    if (q == 0){return 1;}
    if (dp[q] != 0){return dp[q];}
    else{return permutations(q - 1) * q;}
}

long long combinations(int n, int m) // m > n!
{
    return (permutations(m) / permutations(m - n)) / permutations(n);
}

int main()
{
    int M; int N; cin >> N >> M;
    vector<int> kinds;
    for (int i = 0; i < N; i++)
    {
        int onekind; cin >> onekind;
        kinds.push_back(onekind);
    }
    sort(kinds.begin(), kinds.end());
    // 0 - L; 1 - R; 2 - K
    vector<tuple<int, int, int>> orders;
    // Works
    for (int i = 0; i < M; i++)
    {
        int L, R, K; cin >> L >> R >> K;
        orders.push_back(make_tuple(L, R, K));
        vector<int> use;
        for (int j = 0; j < kinds.size(); j++)
        {
            if (get<0>(orders.at(i)) <= kinds.at(j) && get<1>(orders.at(i)) >= kinds.at(j))
            {
                use.push_back(j);
            }
        }
        int answer = 0;
        for (int m = 0; m < use.size(); m++)
        {
            int comb = combinations(m + 1, use.size());

            if (comb >= get<2>(orders.at(i)))
            {
                answer = m + 1;
                break;
            }
        }
        if (answer == 0){answer = -1;}
        use.clear();
        cout << answer << endl;
    }
}
