#include <bits/stdc++.h>
#define in cin
#define out cout

using namespace std;
using ll = long long;
const ll oo = 1e18;
const ll B = 10; // baza nr mari

struct nr_mare{
    vector<int> v;
};

nr_mare operator*( const nr_mare & a, const nr_mare & b ){
    nr_mare c;
    c.v.resize(a.v.size() + b.v.size() - 1);
    for(int i = 0; i < c.v.size(); i++) c.v[i] = 0;
    for(int i = 0; i < a.v.size(); i++){
        for(int j = 0; j < b.v.size(); j++){
            c.v[i + j] += a.v[i] * b.v[j];
        }
    }

    int t = 0;
    for(int i = 0; i < c.v.size() || t > 0; i++){
        if(i < c.v.size()){
            t += c.v[i];
            c.v[i] = t % B;
            t /= B;
        }else{
            c.v.push_back(t % B);
            t /= B;
        }
    }

    return c;
}

nr_mare operator*( const nr_mare & a, const ll & b ){
    nr_mare c;
    int t = 0;
    for(int i = 0; i < a.v.size() || t > 0; i++){
        if(i < a.v.size()) t += a.v[i] * b;
        c.v.push_back(t % B);
        t /= B;
    }

    return c;
}

bool operator<=( const nr_mare & a, const nr_mare & b ){
    if(a.v.size() != b.v.size()) return a.v.size() < b.v.size();
    for(int i = a.v.size() - 1; i >= 0; i--){
        if(a.v[i] != b.v[i]) return a.v[i] < b.v[i];
    }
    return true;
}

nr_mare f[3001];

int main()
{
    int n, m; in >> n >> m;
    int v[n];
    for(int i = 0; i < n; i++) in >> v[i];
    sort(v + 0, v + n);

    f[0].v = {1};
    for(ll i = 1; i <= n; i++){
        //if(f[i - 1] > oo / i) break;
        f[i] = f[i - 1] * i;
    }

    /*cout << "f[n] : ";
    for(int i = f[n].v.size() - 1; i >= 0; i--) cout << f[n].v[i];
    cout << '\n';*/

    for(int _i = 0; _i < m; _i++){
        ll l, r, k; in >> l >> r >> k;
        int clc = 0;
        for(int i = 0; i < n; i++){
            if(l <= v[i] && v[i] <= r) clc++;
        }

        if(clc == 0){
            out << "-1\n";
            continue;
        }

        //cout << "clc = " << clc << '\n';

        int xmin = -1;
        for(int x = 1; x <= clc; x++){
            //cout << "clc = " << clc << " x = " << x << "C = " << f[clc] / (f[x] * f[clc - x]) << '\n';
            if((f[x] * f[clc - x]) * k <= f[clc]){
                xmin = x;
                break;
            }
        }
        out << xmin << '\n';
    }

    return 0;
}

/*
15 1000
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
1 1 6435
*/
