#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct ll {
    vector<int> v;

    ll(const string &x)
    {
        for (int i = x.size()-1; i >= 0; i--)
        {
            v.push_back(x[i]-'0');
        }
    }

    ll(const ll &x)
    {
        v.clear();
        for (auto it:x.v)
        {
            v.push_back(it);
        }
    }

    void fix()
    {
        for (int i = 0; i < v.size(); i++)
        {
            if (v[i] >= 10)
            {
                if (i < v.size()-1)
                {
                    v[i+1] += v[i]/10;
                }
                else
                {
                    v.push_back(v[i]/10);
                }
                v[i] %= 10;
            }
        }
    }

    ll(int x)
    {
        v.clear();
        v.push_back(x);
        fix();
    }

    bool lessthan(ll &other)
    {
        if (other.v.size() != v.size()) return v.size() < other.v.size();
        for (int i = v.size()-1; i >= 0; i--)
        {
            if (v[i] < other.v[i]) return 1;
            else if (v[i] > other.v[i]) return 0;
        }
        return 0;
    }

    void mul(int x)
    {
        for (int i = 0; i < v.size(); i++)
        {
            v[i] *= x;
        }
        fix();
    }

    void div(int x)
    {
        vector<int> r;
        int cv = 0;
        for (int i = v.size()-1; i >= 0; i--)
        {
            cv *= 10;
            cv += v[i];
            r.push_back(cv/x);
            cv %= x;
        }
        reverse(r.begin(), r.end());
        while (r.size() && *r.rbegin() == 0) r.pop_back();
        v.clear();
        for (auto it:r)
        {
            v.push_back(it);
        }
    }
};

int n, m, f[100005], l, r; string gol; ll k(gol); ll wowthisisabadidea(gol);

ll& factminus(int x, int except)
{
    string s = "1";
    wowthisisabadidea = ll(s);
    for (int i = except+1; i <= x; i++)
        wowthisisabadidea.mul(i);
    return wowthisisabadidea;
}

void divbyfact(int x, ll& todiv)
{
    for (int i = 2; i <= x; i++)
        todiv.div(i);
}

void getcombinari(ll &r, int n, int k)
{
    string z = "0";
    if (k > n)
    {
        r = ll(z);
        return;
    }
    r = factminus(n, max(k, n-k));
    divbyfact(min(k, n-k), r);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        f[x]++;
    }
    for (int i = 1; i < 100005; i++)
    {
        f[i] += f[i-1];
    }
    for (int i = 0; i < m; i++)
    {
        string ks;
        cin >> l >> r >> ks;
        k = ll(ks);
        int available = f[r];
        if (l) available -= f[l-1];
        ll possible(available); int size = 1;
        while (possible.lessthan(k) && size <= available/2)
        {
            size++;
            getcombinari(possible, available, size);
        }
        if (!possible.lessthan(k))
            cout << size << "\n";
        else
            cout << "-1\n";
    }
}