#include <iostream>
#include <vector>
#include <climits>

using namespace std;

struct connection {
    int other, length;
};

int n, k; vector<connection> c[200005]; connection parent[200005]; int depth[200005];

void dfs(int nod, int currentdepth)
{
    depth[nod] = currentdepth;
    for (auto it:c[nod])
    {
        if (!depth[it.other])
        {
            parent[it.other] = {nod, it.length};
            dfs(it.other, currentdepth+it.length);
        }
    }
}

int fcadepth(int x, int y)
{
    while (x != y)
    {
        if (depth[x] < depth[y])
        {
            y = parent[y].other;
        }
        else
        {
            x = parent[x].other;
        }
    }
    return depth[x];
}

int main()
{
    cin >> n >> k;
    for (int i = 0; i < n-1; i++)
    {
        int u, v, w;
        cin >> u >> v >> w;
        c[u].push_back({v, w});
        c[v].push_back({u, w});
    }
    dfs(1, 1);
    int r = 0;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            r = max(r, depth[i]+depth[j]-2*fcadepth(i, j));
        }
    }
    cout << r;
}