#include <bits/stdc++.h>

#define ll long long
#define ull unsigned long long
#define pb(x) push_back(x)
#define ins(x) insert(x)
#define mp(x,y) make_pair(x,y)
#define fast_ios ios_base::sync_with_stdio(0); cin.tie(NULL); cout.tie(NULL);


using namespace std;
priority_queue<ll,vector<ll>>pq;
ll dijktra ( vector<vector<pair<ll,ll>>>graph , ll n , ll start , int wwww )
{
vector<ll>costs(n+1);
for ( ll i = 1 ; i <= n ; ++ i )
    costs[i]=INT_MAX;
costs[start]=0;
priority_queue<pair<ll,ll>,vector<pair<ll,ll>>,greater<pair<ll,ll>>>coada;
coada.push(mp(0,start));
while(!coada.empty())
{
    ll nod = coada.top().second;
    ll cost = coada.top().first ;
    coada.pop();
    if ( cost > costs[nod] )
        continue;
    for ( auto it : graph[nod] )
    {
        if ( costs[it.first] > cost + it.second )
        {
            costs[it.first] = cost + it.second ;
            coada.push(mp(costs[it.first],it.first));
        }
    }
}
ll nr = 0 ;
ll max1 = 0;
for ( ll i = 1 ; i <= n ; ++ i ){
    if ( wwww != -1 )
    pq.push(costs[i]);
    if ( max1 < costs[i] )
    {
        max1 = costs[i] ;
        nr = i ;
    }
    }
return nr ;
}

signed main()
{
    fast_ios
    ll n, k ;
    cin >> n >> k;
    vector<vector<pair<ll,ll>>>graph(n+1);
    for ( ll i = 1 ;i <= n-1 ; ++ i )
    {
        ll a , b , x ;
        cin >> a >> b >> x ;
        graph[a].pb(mp(b,x));
        graph[b].pb(mp(a,x));
    }
    ll start = dijktra(graph,n,1,-1);
    ll www = dijktra(graph,n,start,start);

    while(k && pq.top())
    {
        int x = pq.top();
        pq.pop();
        --x;
        pq.push(x);
        --k;
    }
    cout << pq.top() ;
    return 0;
}
