#include <bits/stdc++.h>

using namespace std;

const int nmax=1e5;
int n,m,k,l,r,sp[nmax+5],a[3005],v[1005],up[1005];

unordered_map <int,int> mp;

void multiply(int a[], int n)
{
    int t=0;
    for (int i=1; i<=a[0]; ++i,t/=10 )
    {
        t+=a[i]*n;
        a[i]=t%10;
    }

    while ( t )
    {
        a[++a[0]]=t%10;
        t/=10;
    }
}

void divide(int a[], int n)
{
    int r=0;
    for (int i=a[0]; i>=1; i-- )
    {
        r=r*10+a[i];
        a[i]=r/n;
        r%=n;
    }

    while ( a[a[0]]==0 && a[0]>1 )
        a[0]--;
}

int comb(int n, int k)
{
    up[0]=1,up[1]=1;

    for (__int128 i=n-k+1,j=1; i<=n; i++,j++ )
    {
        multiply(up,i);

        if ( j<=k )
            divide(up,j);
    }
}

int compare(int a[], int v[] )
{
    if ( a[0]>v[0] )
        return 1;

    if ( a[0]<v[0] )
        return -1;

    int i=a[0];
    while ( a[i]==v[i] && i>0 )
        i--;

    if ( a[i]>v[i] )
        return 1;

    if ( a[i]<v[i] )
        return 2;

    return 0;
}

void reset()
{
    for (int i=0; i<=v[0]; i++ )
        v[i]=0;

    for (int i=0; i<=up[0]; i++ )
        up[i]=0;
}


__int128 combnormala(int n, int k)
{
    __int128 up=1,down=1;
    for (int i=1; i<=n; i++ )
        up*=i;

    for (int i=1; i<=k; i++ )
        down*=i;

    for (int i=1; i<=n-k; i++ )
        down*=i;
    return up/down;
}

__int128 combsubtask2(int n, int k)
{
    __int128 up=1;

    for (__int128 i=n-k+1,j=1; i<=n; i++,j++ )
    {
        up=1ULL*up*i;
        if ( j<=k )
            up=1ULL*up/j;
    }

    return up;
}

int c[3005][3005];

const int mxpascal=3000;

__int128 maketoint(string s)
{
    __int128 nr=0;
    for (int i=0; i<s.size(); i++ )
        nr=1ULL*(nr*10+(s[i]-'0'));
    return 1ULL*nr;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m;

    //pascal();

    int maxi=0;
    for (int i=1; i<=n; i++ )
    {
        cin >> a[i];
        maxi=max(maxi,a[i]);
        mp[a[i]]++;
    }

    for (int i=1; i<=nmax; i++ )
        sp[i]=sp[i-1]+mp[i];

    while ( m-- )
    {
        int l,r;

        reset();

        string k;

        cin >> l >> r >> k;

        if ( k=="1" )
        {
            int nr=sp[r]-sp[l-1];
            if ( nr>0 )
                cout << 1 << '\n';
            else cout << -1 << '\n';
            continue;
        }

        if ( n<=15 )
        {
            int kk=maketoint(k);
            int nr=0;

            if ( sp[r]>sp[l-1] )
               nr=sp[r]-sp[l-1];
            else
            {
                cout << -1 << '\n';
                continue;
            }

            int res=0;
            for (int lg=1; lg<=nr; lg++ )
            {
                if ( combnormala(nr,lg)>=kk  )
                {
                    res=lg;
                    break;
                }
            }
            if ( res==0 )
                cout << -1 << '\n';
            else cout << res << '\n';
        }
        else if ( n<=50 )
        {
            __int128 kk=maketoint(k);
            int nr=0;

            // nr nu depaseste 50 deci ne intra factorial de 50

            if ( sp[r]>sp[l-1] )
               nr=sp[r]-sp[l-1];
            else
            {
                cout << -1 << '\n';
                continue;
            }

            int res=0;
            for (int lg=1; lg<nr; lg++ )
            {
                if ( combsubtask2(nr,lg)>=kk  )
                {
                    res=lg;
                    break;
                }
            }

            if ( res==0 )
                cout << -1 << '\n';
            else cout << res << '\n';
        }
        else
        {
            int sz=k.size();
            // combinari de nr luate cate lg
            int t=0;

            v[0]=sz;
            for (int i=sz-1; i>=0; i-- ) // are maxim 18 cifre, de cee nu intra in timp
                v[++t]=k[i]-'0';

            int nr=sp[r]-sp[l-1]; // imi iese din timp la combinari wtf

            int res=0;
            for (int lg=1; lg<nr; lg++ )
            {
                comb(nr,lg);
                int ok=compare(up,v); // daca up>=v avem buchet

                if ( ok==1 || ok==0 )
                {
                    res=lg;
                    break;
                }
            }
            if ( res==0 )
                cout << -1 << '\n';
            else cout << res << '\n';
        }
    }

    //cout << c[6][2] << '\n';


    /*v[0]=1,v[1]=9;
    multiply(v,3);
    for (int i=v[0]; i>=1; i-- )
        cout << v[i] << " ";*/
    /*v[0]=3,v[1]=9,v[2]=7,v[3]=5;
    divide(v,12);
    /*for (int i=v[0]; i>=1; i-- )
        cout << v[i] << " ";*/

    return 0;
}
/*7 3
3 4 1 1 6 1 2
1 3 1
1 4 1
1 5 1*/

