#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
ll inf = -200000000000;
void dijkstra(int & pocetak, vector<vector<pair<int, int>>> & stablo, vector<ll> & udaljenosti, int & n){
    priority_queue<pair<ll, int>>q;
    vector<bool>posetili(n, false);
    udaljenosti[pocetak] = 0;
    q.push(make_pair(0, pocetak));
    while(!q.empty()){
        int tr = q.top().second;
        q.pop();
        if(posetili[tr]) continue;
        posetili[tr] = true;
        for(auto x : stablo[tr]){
            int b1 = x.first, w1 = x.second;
            if(udaljenosti[b1] < (udaljenosti[tr] + w1 and !posetili[b1])){
                udaljenosti[b1] = udaljenosti[tr] + w1;
                q.push(make_pair(udaljenosti[b1], b1));
            }
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k, a, b, w;
    cin >> n >> k;
    vector<vector<pair<int, int>>>stablo(n);
    for(int i = 0; i < (n - 1); i++){
        cin >> a >> b;
        cin >> w;
        a -= 1;
        b -= 1;
        stablo[a].push_back(make_pair(b, w));
        stablo[b].push_back(make_pair(a, w));
    }
    int pocetak = 0;
    vector<ll>udaljenosti1(n, inf);
    dijkstra(pocetak, stablo, udaljenosti1, n);
    int maks = 0;
    int najdalji = 0;
    for(int i = 0; i < n; i++){
        if(udaljenosti1[i] > maks){
            maks = udaljenosti1[i];
            najdalji = i;
        }

    }
    vector<ll>udaljenosti(n, inf);
    pocetak = najdalji;
    dijkstra(pocetak, stablo, udaljenosti, n);
    priority_queue<pair<ll, int>>q;
    for(int i = 0; i < n; i++){
        q.push(make_pair(udaljenosti[i], i));
    }
    if(k == 0){
        cout << q.top().first;
    }
    else if(k == 1){
        int br1 = q.top().first - 1;
        q.pop();
        int br2 = q.top().first;
        cout << max(br1, br2);
    }
    else{
        while(k > 0){
            int dalekopoz, dalekokol, sledeci;
            dalekopoz = q.top().second;
            dalekokol = q.top().first;
            q.pop();
            sledeci = q.top().first;
            k -= 1;





        }
    }


}
