#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
ll inf = -200000000000;
void dijkstra(ll & pocetak, vector<vector<pair<ll, ll>>> & stablo, vector<ll> & udaljenosti, ll & n){
    priority_queue<pair<ll, ll>>q;
    vector<bool>posetili(n, false);
    udaljenosti[pocetak] = 0;
    q.push(make_pair(0, pocetak));
    while(!q.empty()){
        ll tr = q.top().second;
        q.pop();
        if(posetili[tr]) continue;
        posetili[tr] = true;
        for(auto x : stablo[tr]){
            ll b1 = x.first, w1 = x.second;
            if(udaljenosti[b1] < (udaljenosti[tr] + w1 and !posetili[b1])){
                udaljenosti[b1] = udaljenosti[tr] + w1;
                q.push(make_pair(udaljenosti[b1], b1));
            }
        }
    }
}
void smanjujemo(ll & roditelj, vector<ll> & udaljenosti, vector<vector<pair<ll, ll>>> & stablo, ll & oduzecemo, ll & sin){
    //cout << sin << endl << roditelj << endl << endl;
    if(oduzecemo == 0)
        return;
    ll noviroditelj = 0;
    for(auto x : stablo[roditelj]){
        ll b = x.first, w = x.second;
        if(!(udaljenosti[b] == udaljenosti[roditelj] - w)){
            if(x.first == sin){
                x.second -= min(x.second, oduzecemo);
                udaljenosti[sin] -= oduzecemo;
                //cout << sin << endl;
                oduzecemo -= min(x.second, oduzecemo);
            }


        }
        else{
            noviroditelj = b;
        }


    }

    smanjujemo(noviroditelj, udaljenosti, stablo, oduzecemo, roditelj);
    return;


}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll n, k, a, b, w;
    cin >> n >> k;
    vector<vector<pair<ll, ll>>>stablo(n);
    for(ll i = 0; i < (n - 1); i++){
        cin >> a >> b;
        cin >> w;
        a -= 1;
        b -= 1;
        stablo[a].push_back(make_pair(b, w));
        stablo[b].push_back(make_pair(a, w));
    }
    ll pocetak = 0;
    vector<ll>udaljenosti1(n, inf);
    dijkstra(pocetak, stablo, udaljenosti1, n);
    ll maks = 0;
    ll najdalji = 0;
    for(ll i = 0; i < n; i++){
        if(udaljenosti1[i] > maks){
            maks = udaljenosti1[i];
            najdalji = i;
        }
    }
    vector<ll>udaljenosti(n, inf);
    pocetak = najdalji;
    dijkstra(pocetak, stablo, udaljenosti, n);
    priority_queue<pair<ll, ll>>q;
    for(ll i = 0; i < n; i++){
        q.push(make_pair(udaljenosti[i], i));
    }
    if(k == 0){
        cout << q.top().first;
    }
    else if(k == 1){
        ll br1 = q.top().first - 1;
        q.pop();
        ll br2 = q.top().first;
        cout << max(br1, br2);
    }
    else{
        while(k > 0){
            //cout << "smzm" << endl;
            ll dalekopoz, dalekokol, sledeci;
            ll maksi1 = 0, maksi2 = 0;
            for(ll i = 0; i < n; i++){
                if(maksi1 < udaljenosti[i]){
                    maksi2 = maksi1;
                    maksi1 = udaljenosti[i];
                    dalekokol = maksi1;
                    dalekopoz = i;
                }
                else if (maksi2 < udaljenosti[i]){
                    maksi2 = udaljenosti[i];
                }
            }
         //   cout << maksi1 << endl;
           // cout << maksi2 << endl;
            sledeci = maksi2;
            ll oduzecemo = min(((dalekokol - sledeci) + 1), k); /* mozda bug */
            //cout << oduzecemo << endl;
            k -= oduzecemo;
            ll roditelj;
            for(auto x : stablo[dalekopoz]){
                ll sused = x.first, duzina = x.second;
                if(udaljenosti[dalekopoz] == (udaljenosti[sused] + duzina)){
                    roditelj = sused;
                    break;
                }
            }
           // cout << roditelj << endl << dalekopoz << endl;
            ll sin = dalekopoz;
            //cout << sin << endl;
            smanjujemo(roditelj, udaljenosti, stablo, oduzecemo, sin);
            //cout << "smz2222m" << endl;

        }
        ll maks3 = 0;
        for(auto x : udaljenosti){
            //cout << x << " ";
            maks3 = max(maks3, x);
        }
        cout << maks3;
    }


}
