#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<vector<pair<int, int>>> gr;

pair<ll, ll> dfsFindDim(int u, int p) {
    ll dim = 0;
    vector<ll> pths;
    for (auto [v, w] : gr[u]) {
        if (v != p) {
            auto [dm, pt] = dfsFindDim(v, u);
            pt += w;
            dim = max(dim, dm);
            pths.push_back(pt);
        }
    }
    sort(pths.rbegin(), pths.rend());
    pths.push_back(0);
    dim = max(dim, pths[0] + (pths.size() > 1 ? pths[1] : 0));
    return {dim, pths[0]};
}

int main() {
    int n, k;
    cin >> n >> k;
    gr.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        gr[u - 1].emplace_back(v - 1, w);
        gr[v - 1].emplace_back(u - 1, w);
    }
    cout << dfsFindDim(0, -1).first << "\n";
}