#include <bits/stdc++.h>

using namespace std;

using ll = long long;

string su(string a1, string b1) {
    string a = a1;
    string b = b1;
    ll n = (ll)a.size();
    ll m = (ll)b.size();
    ll vsp = 0;
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    string ans = "";
    for (ll i = 0; i < max(n, m); i++) {
        ll v = vsp;
        if (i < n) {
            v += a[i] - '0';
        }
        if (i < m) {
            v += b[i] - '0';
        }
        ans += char('0' + v % 10);
        vsp = v / 10;
    }
    if (vsp) {
        ans += "1";
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

bool big(string bi, string sma) {
    if (bi.size() > sma.size()) {
        return 1;
    }
    if (bi.size() < sma.size()) {
        return 0;
    }
    for (int i = 0; i < (int)sma.size(); i++) {
        if (bi[i] > sma[i]) {
            return 1;
        }
        if (bi[i] < sma[i]) {
            return 0;
        }
    }
    return 1;
}


signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ll n, t;
    cin >> n >> t;
    vector<vector<string>> re(n + 1, vector<string>(n + 1));
    for (int i = 0; i <= n; i++) {
        re[i][0] = "1";
        re[i][i] = "1";
    }
    for (int i = 2; i <= n; i++) {
        for (int j = 1; j < i; j++) {
            re[i][j] = su(re[i - 1][j], re[i - 1][j - 1]);
        }
    }
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    while (t--) {
        ll l, r;
        cin >> l >> r;
        ll cnt = upper_bound(a.begin(), a.end(), r) - lower_bound(a.begin(), a.end(), l);
        string v;
        cin >> v;
        ll r1 = cnt / 2;
        if (big(re[cnt][r1], v)) {
            ll l1 = 0;
            while (r1 - l1 > 1) {
                ll m = (r1 + l1) / 2;
                if (big(re[cnt][m], v)) {
                    r1 = m;
                } else {
                    l1 = m;
                }
            }
            cout << r1 << endl;
        } else {
            cout << -1 << endl;
        }
    }
}