#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<vector<int>> g;
vector<vector<pair<int, int>>> g1;
vector<int> d;
int n;

vector<int> di;


void dfs2(int u, int p, int dist = 1) {
    for (auto v : g[u]) {
        if (v != p) {
            dfs2(v, u, dist + 1);
        }
    }
    di.push_back(dist);
}

vector<int> cen;

void dfs(int u, int p = -1) {
    ll su = 0;
    ll fl = 1;
    for (auto v : g[u]) {
        if (v != p) {
            dfs(v, u);
            su += d[v];
            if (d[v] > n / 2) {
                fl = 0;
            }
        }
    }
    if (fl && (n - su - 1) <= n / 2) {
        cen.push_back(u);
    }
    d[u] = su + 1;
}

vector<int> dist;
void dfs1(int u, int p = -1) {
    for (auto [v, w] : g1[u]) {
        if (v != p) {
            dfs1(v, u);
            dist[u] = max(dist[u], dist[v] + w);
        }
    }
}

signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ll k;
    cin >> n >> k;
    if (k > n) {
        cout << 0 << endl;
        return 0;
    }
    g.resize(n);
    g1.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        g1[u].push_back({v, w});
        g1[v].push_back({u, w});
    }
    d.resize(n);
    dfs(0);
    dist.resize(n);
    dfs1(cen[0]);
    vector<set<int>> se;
    vector<int> cnt;
    vector<int> num(n);
    for (auto v : g[cen[0]]) {
        num[v] = cnt.size();
        di.resize(0);
        dfs2(v, cen[0]);
        set<int> se1;
        ll ma = 0;
        ll ima = 0;
        for (auto i : di) {
            se1.insert(i);
            if (i > ma) {
                ma = i;
                ima = 1;
            } else if (i == ma) {
                ima++;
            }
        }
        se.push_back(se1);
        ll cu = 0;
        cnt.push_back(ima);
    }
    set<pair<int, int>> ans;
    for (auto [v, w] : g1[cen[0]]) {
        ans.insert({-(dist[v] + w), num[v]});
    }
    while (ans.size() > 0) {
        auto [u, v] = *ans.begin();
        ans.erase({u, v});
        if (cnt[v] > k) {
            ans.insert({u, v});
            break;
        }
        else {
            k -= cnt[v];
            cnt[v] = 0;
            ll d = (-1 * u) - 1;
            while (se[v].find(d) != se[v].end()) {
                cnt[v]++;
                se[v].erase(se[v].find(d));
            }
        }
        if (u != -1) {
            ans.insert({u + 1, v});
        }
    }
    vector<int> an;
    for (auto [u, v] : ans) {
        an.push_back(-1 * u);
    }
    if (ans.size() == 0) {
        cout << 0 << endl;
    }
    else if (ans.size() == 1) {
        cout << an[0];
    }
    else {
        cout << an[0] + an[1];
    }
}