#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<set<int>> g;
vector<int> d;
set<int> good;
int n;

vector<int> cen;

void dfs(int u, int p = -1) {
    ll su = 0;
    ll fl = 1;
    for (auto v : g[u]) {
        if (v != p && good.find(v) != good.end()) {
            dfs(v, u);
            su += d[v];
            if (d[v] > (good.size()) / 2) {
                fl = 0;
            }
        }
    }
    if (fl && ((good.size()) - su - 1) <= (good.size()) / 2) {
        cen.push_back(u);
    }
    d[u] = su + 1;
}

vector<int> dist;
void dfs1(int u, int p = -1) {
    for (auto v : g[u]) {
        if (v != p && good.find(v) != good.end()) {
            dfs1(v, u);
            dist[u] = max(dist[u], dist[v] + 1);
        }
    }
}

ll ans(ll &k) {
    cen.resize(0);
    d.assign(n, 0);
    dist.assign(n, 0);
    if (good.size() == 2) {
        k = 0;
        return 0;
    } 
    dfs(*good.begin());
    dfs1(cen[0]);
    vector<pair<int, int>> ans;
    ans.resize(0);
    for (auto v : g[cen[0]]) {
        ans.push_back({dist[v] + 1, v});
    }
    sort(ans.rbegin(), ans.rend());
    if (k) {
        k--;
        ans[0].first--;
        auto x = ans[0].second;
        g[cen[0]].erase(x);
        g[x].erase(cen[0]);
        vector<int> vsp;
        for (auto e : g[x]) {
            g[cen[0]].insert(e);
            vsp.push_back(e);
        }
        for (auto e : vsp) {
            g[x].erase(e);
        }
        good.erase(x);
    }
    sort(ans.rbegin(), ans.rend());
    return ans[0].first + ans[1].first;
}

signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ll k;
    cin >> n >> k;
    if (k > n) {
        cout << 0 << endl;
        return 0;
    }
    g.resize(n);
    for (int i = 0; i < n; i++) {
        good.insert(i);
    }
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].insert(v);
        g[v].insert(u);
    }
    ll v = 0;
    while (k > 0) {
        v = ans(k);
    }
    cout << v << endl;
}