#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
const ll INF = 1e18 + 7;
const ll MAXC = 301;

ll n, c_o;
vector<ll> dd;
vector<vector<pii>> g;

void dfs(ll v, ll p, ll _d) {
    dd[v] = _d;
    for (auto &[u, w] : g[v]) {
        if (u != p) {
            dfs(u, v, _d + w);
        }
    }
}

pii diam() {
    dd.assign(n, 0);
    dfs(0, -1, 0);

    ll v = 0;
    for (ll i = 1; i < n; i++) {
        if (dd[i] > dd[v]) {
            v = i;
        }
    }


    dd.assign(n, 0);
    dfs(v, -1, 0);

    ll u = 0;
    for (ll i = 1; i < n; i++) {
        if (dd[i] > dd[u]) {
            u = i;
        }
    }

    return {v, u};
}

void solve() {
    cin >> n >> c_o;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll v, u, w;
        cin >> v >> u >> w;
        --v; --u;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }

    auto [v, u] = diam();
    cout << dd[u] << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}
