#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
mt19937 rnd('S' + 'E' + 'E' + 'D');
const ll INF = 1e18 + 7;
const ll MAXC = 301;

int n, c_o;
vector<int> dd;
vector<vector<pii>> g;

void dfs(int v, int par, int _d) {
    dd[v] = _d;
    for (auto &[u, w] : g[v]) {
        if (u != par) {
            dfs(u, v, _d + w);
        }
    }
}

pii diam() {
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    //shuffle(ord.begin(), ord.end(), rnd);
    dd.assign(n, 0);
    dfs(0, -1, 0);

    int v = 0;
    for (auto &i : ord) {
        if (dd[i] > dd[v]) {
            v = i;
        }
    }


    dd.assign(n, 0);
    dfs(v, -1, 0);

    int u = 0;
    for (auto &i : ord) {
        if (dd[i] > dd[u]) {
            u = i;
        }
    }

    return {v, u};
}

void mod_e(int v, int u, int dl) {
    for (auto &[i, w] : g[v]) {
        if (i == u) w += dl;
    }
    for (auto &[i, w] : g[u]) {
        if (i == v) w += dl;
    }
}

vector<int> cr, p;
void rest(int v, int par, int nd) {
    p.push_back(v);
    if (v == nd) cr = p;
    for (auto &[u, w] : g[v]) {
        if (u != par) {
            rest(u, v, nd);
        }
    }
    p.pop_back();
}

void solve() {
    cin >> n >> c_o;
    //n = 1e4;
    //c_o = 1;
    g.assign(n, {});
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        --v; --u;
        //v = i;
        //u = i + 1;
        //w = 1;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }

    auto [v, u] = diam();
    p.clear();
    cr.clear();
    rest(v, -1, u);
    auto v1 = cr;
    int w = -1;
    for (int i = 0; i < n; i++) {
        if (i != u && dd[i] == dd[u]) {
            w = i;
        }
    }
    vector<int> v2 = {};
    if (w != -1) {
        p.clear();
        cr.clear();
        rest(v, -1, w);
        v2 = cr;
    }

    vector<pii> w1;
    for (int i = 0; i < (int)v1.size() - 1; i++) {
        w1.push_back({v1[i], v1[i + 1]});
    }
    vector<pii> w2;
    for (int i = 0; i < (int)v2.size() - 1; i++) {
        w2.push_back({v2[i], v2[i + 1]});
    }
    for (auto &[v1, u1] : w1) {
        if (v1 > u1) swap(v1, u1);
    }
    for (auto &[v1, u1] : w2) {
        if (v1 > u1) swap(v1, u1);
    }
    sort(w2.begin(), w2.end());

    vector<pii> ws;
    for (auto &[v1, u1] : w1) {
        if (binary_search(w2.begin(), w2.end(), pii{v1, u1})) {
            ws.push_back({v1, u1});
        }
    }
    //if ((int)ws.size() > 10) throw(0);


    int mn = dd[u];
    if (w2.empty()) {
        if (c_o) {
            shuffle(w1.begin(), w1.end(), rnd);
            int sz = w1.size();
            for (int i = 0; i < min(sz, 15); i++) {
                auto [v2, u2] = w1[i];
                mod_e(v2, u2, -1);
                auto [v1, u1] = diam();
                mn = min(mn, dd[u1]);
                mod_e(v2, u2, 1);
            }
            /*for (int i = sz - 1; i >= max(0int, sz - 1 - 15); i--) {
                auto [v, u] = ws[i];
                mod_e(v, u, -1);
                auto [v1, u1] = diam();
                mn = min(mn, dd[u1]);
                mod_e(v, u, 1);
            }*/
        }
    } else {
        if (ws.empty()) {
            ws.push_back(w1[0]);
        }
        shuffle(ws.begin(), ws.end(), rnd);
        int sz = ws.size();
        for (int i = max(0, sz / 2 - 6); i <= min(sz - 1, sz / 2 + 5); i++) {
            auto [v2, u2] = ws[i];
            mod_e(v2, u2, -1);
            auto [v1, u1] = diam();
            mn = min(mn, dd[u1]);
            mod_e(v2, u2, 1);
        }
    }

    cout << mn << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << endl;
    #endif
}
