#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<functional>
#include<numeric>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmin(a, b) a = min(a, b)
#define chmax(a, b) a= max(a, b)

void solve() {
	int n, m; cin >> n >> m;
	vector<int> a(n); cin(a);
	sort(all(a));
	for (int i = 0; i < m; ++i) {
		int l, r, k; cin >> l >> r >> k;
		int cnt = (upper_bound(all(a), r) - a.begin()) - (lower_bound(all(a), l) - a.begin());
		if (cnt) cout << 1 << "\n";
		else cout << -1 << "\n";
	}
}

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
}