#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<functional>
#include<numeric>
#include "monopoly2.h"
using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmin(a, b) a = min(a, b)
#define chmax(a, b) a= max(a, b)
#define pii pair<int, int>
#define tiii tuple<int, int, int>
const int M = 1e18;

vector <pair <int, int> > find_connections(int n) {
	vector<pii> e;
	if (n == 1) return {};
	vector<int> p(n); iota(all(p), 1);
	int j = 1;
	vector<bool> used(n + 1);
	vector<int> right(n + 1, 0);
	while (e.size() < n - 1) {
		if (used[p[j]]) {
			++j; continue;
		}
		vector<int> p1 = p, p2;
		int l = 0, r = j - right[p[j]] - 1;
		vector<bool> b1;
		while (l + 1 != r) {
			int m = (l + r) / 2;
			rotate(p1.begin() + j - m, p1.begin() + j, p1.begin() + j + 1);
			vector<bool> b = check(p1);
			if (b[j - m] == 1) {
				r = m;
				b1 = b; p2 = p1;
			}
			else {
				l = m;
			}
			p1 = p;
		}
		if (b1.size()) {
			bool f = 0;
			for (int i = j - r + 2; i < n; ++i) {
				if (!f && b1[i] == 1) {
					e.push_back({ p[j], p2[i] });
					used[p2[i]] = 1; f = 1;
				}
				if (b1[i] == 1) {
					right[p2[i]] = p[j];
				}
			}
		}
		used[p[j]] = 1;
		e.push_back({ p[j - r], p[j] }); ++j;
	}
	
	return e;
}

/*void solve() {
	
}

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
*/