#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<functional>
#include<numeric>
#include "monopoly2.h"
using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmin(a, b) a = min(a, b)
#define chmax(a, b) a= max(a, b)
#define pii pair<int, int>
#define tiii tuple<int, int, int>
const int M = 1e18;

vector<pii> e;
vector<int> p;
vector<int> used;
void dfs(int v, vector<bool> ispr, int n) {
	used[v] = 1;
	vector<int> p1 = p;
	for (int i = 0; i < n; ++i) {
		if (ispr[i] == 0 || i + 1 == v) continue;
		int pri = i + 1;
		e.push_back({ v, pri });
		swap(p1[v - 1], p1[pri - 1]);
		vector<bool> b = check(p1);
		swap(p1[v - 1], p1[pri - 1]);
		swap(b[v - 1], b[pri - 1]);
		for (int j = 0; j < n; ++j) {
			if (used[j + 1] && b[j] == 1) b[j] = 0;
		}
		for (int j = 0; j < n; ++j) {
			if (!used[j + 1] && ispr[j] && b[j]) ispr[j] = 0;
		}
		dfs(pri, b, n);
	}
}
vector <pair <int, int> > find_connections(int n) {
	if (n == 1) return {};
	p.resize(n); iota(all(p), 1);
	vector<bool> ispr(n, 1);
	used.resize(n + 1);
	dfs(1, ispr, n);

	return e;
}


/*void solve() {

}

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
*/