#include <bits/stdc++.h>

using namespace std;
vector<long long> fact;
int binsearch (int cnt, int k) {
    int l = 0, r = (cnt + 1) / 2;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (fact[cnt] / fact[m] / fact[cnt - m] >= k) {
            r = m;
        } else {
            l = m;
        }
    }
    if (fact[cnt] / fact[r] / fact[cnt - r] >= k) {
        return r;
    }
    return -1;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    if (n <= 15) {
        fact.resize(n + 1);
        fact[0] = 1;
        for (int i = 1; i <= n; ++i) {
            fact[i] = fact[i - 1] * i;
        }
    }
    while (m--) {
        int l, r, k;
        cin >> l >> r >> k;
        l = lower_bound(a.begin(), a.end(), l) - a.begin();
        r = upper_bound(a.begin(), a.end(), r) - a.begin();
        if (r == l) {
            cout << -1 << '\n';
            continue;
        }
        if (k > 1) {
            cout << binsearch(r - l, k) << '\n';
        } else {
            cout << ((r - l) >= 1) * 2 - 1 << '\n';
        }
    }
}
