#include <bits/stdc++.h>

using namespace std;

bool tr(vector<vector<int>>& B, int a, vector<int>& c) {
    if (B[a].size() != c.size()) return B[a].size() > c.size();
    int n = B[a].size();
    for (int i = n - 1; i >= 0; --i) {
        if (B[a][i] != c[i]) return B[a][i] > c[i];
    }
    return true;
}

struct edge {
    int num, i;
    vector<int> k;
    edge (int num1, vector<int> k1, int i1) {
        num = num1, i = i1, k = k1;
    }
};

bool operator<(edge a, edge b) {
    return a.num < b.num;
}

int main() {
    int n, m, MAXX = 1e6, MAXN = 1e9; cin >> n >> m;
    vector<int> numer(9, 1);
    for (int i = 1; i < 9; ++i) numer[i] = numer[i - 1] * 10;
    vector<int> a(n);
    vector<int> cnt(MAXX, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        cnt[a[i]]++;
    }
    for (int i = 1; i < MAXX; ++i) {
        cnt[i] += cnt[i - 1];
    }
    vector<vector<int>> B0(n + 1), B1(n + 1);
    vector<vector<bool>> used(n + 1, vector<bool> (n + 1, 0));
    B0[0].push_back(1);
    B1[0].push_back(1);
    vector<edge> zap;
    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r;
        int num = cnt[r] - cnt[l - 1];
        string k; cin >> k;
        reverse(k.begin(), k.end());
        vector<int> kk;
        for (int i = 0; i * 9 < k.size(); ++i) {
            int ost = 0;
            if (i * 9 + 0 < k.size()) ost += (k[i * 9 + 0] - '0') * numer[0];
            if (i * 9 + 1 < k.size()) ost += (k[i * 9 + 1] - '0') * numer[1];
            if (i * 9 + 2 < k.size()) ost += (k[i * 9 + 2] - '0') * numer[2];
            if (i * 9 + 3 < k.size()) ost += (k[i * 9 + 3] - '0') * numer[3];
            if (i * 9 + 4 < k.size()) ost += (k[i * 9 + 4] - '0') * numer[4];
            if (i * 9 + 5 < k.size()) ost += (k[i * 9 + 5] - '0') * numer[5];
            if (i * 9 + 6 < k.size()) ost += (k[i * 9 + 6] - '0') * numer[6];
            if (i * 9 + 7 < k.size()) ost += (k[i * 9 + 7] - '0') * numer[7];
            if (i * 9 + 8 < k.size()) ost += (k[i * 9 + 8] - '0') * numer[8];
            kk.push_back(ost);
        }
        zap.push_back(edge(num, kk, i));
    }
    sort(zap.begin(), zap.end());
    int max_a = 2;
    vector<int> ans(m, 0);
    for (int i = 0; i < m; ++i) {
        edge e = zap[i];
        if (e.num <= 0) {
            ans[e.i] = -1;
            continue;
        }
        while (max_a <= e.num) {
            for (int k = 0; k <= n; ++k) {
                B0[k] = B1[k];
                B1[k].clear();
            }
            B0[0].clear();
            B0[0].push_back(1);
            for (int b = 1; b * 2 <= max_a; ++b) {
                if (b >= 1 && b * 2 <= max_a) {
                    int q = B0[b - 1].size(), w = B0[b].size();
                    if (b * 2 > max_a - 1) {
                        w = B0[max_a - 1 - b].size();
                        if (used[max_a - 1 - b][max_a - 1] == 1 || used[b - 1][max_a - 1] == 1) {
                            used[max_a][b] = 1;
                            continue;
                        }
                        int delta = 0;
                        for (int i = 0; i < max(w, q); ++i) {
                            if (i < w) {
                                delta += B0[max_a - 1 - b][i];
                            }
                            if (i < q) {
                                delta += B0[b - 1][i];
                            }
                            B1[b].push_back(delta % MAXN);
                            delta /= MAXN;
                        }
                        if (delta > 0) B1[b].push_back(delta % MAXN);
                        if (B1[b].size() >= 110) used[b][max_a] = 1;
                    } else {
                        if (used[b][max_a - 1] == 1 || used[b - 1][max_a - 1] == 1) {
                            used[max_a][b] = 1;
                            continue;
                        }
                        int delta = 0;
                        for (int i = 0; i < max(w, q); ++i) {
                            if (i < w) {
                                delta += B0[b][i];
                            }
                            if (i < q) {
                                delta += B0[b - 1][i];
                            }
                            B1[b].push_back(delta % MAXN);
                            delta /= MAXN;
                        }
                        if (delta > 0) B1[b].push_back(delta);
                        if (B1[b].size() >= 110) used[b][max_a] = 1;
                    }
                }
            }
            max_a++;
        }
        if (!tr(B1, e.num / 2, e.k)) {
            ans[e.i] = -1;
            continue;
        }
        int left = 0, right = e.num / 2 + 1;
        while (left < right - 1) {
            int mid = (left + right) / 2;
            if (tr(B1, mid, e.k)) {
                right = mid;
            } else {
                left = mid;
            }
        }
        ans[e.i] = right;
    }
    for (auto x : ans) cout << x << '\n';
}
