#include <bits/stdc++.h>

using namespace std;

long long INF = 1e12;
vector<vector<pair<long long, long long>>> g;
vector<long long> p1, p2, ans, used;

void dfs(long long v) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
        if (used[u] == -1) {
            dfs(u);
            if (p2[u] + w > p2[v]) {
                p2[v] = p2[u] + w;
            }
            if (p1[u] + w > p1[v]) {
                p2[v] = p1[v];
                p1[v] = p1[u] + w;
            } else if (p1[u] + w > p2[v]) {
                p2[v] = p1[u] + w;
            }
            ans[v] = max(ans[v], ans[u]);
        }
    }
    ans[v] = max(ans[v], p1[v] + p2[v]);
    ans[v] = max(ans[v], p1[v]);
}

int main() {
    long long n, m; cin >> n >> m;
    g.resize(n);
    used.resize(n, -1);
    p1.resize(n, 0);
    p2.resize(n, 0);
    ans.resize(n, 0);
    for (long long i = 0; i < n - 1; ++i) {
        long long u, v, w; cin >> u >> v >> w; u--, v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    dfs(0);
    cout << ans[0] - m << '\n';
}
