#include <bits/stdc++.h>

using namespace std;

long long INF = 1e12;
vector<vector<pair<long long, long long>>> g;
vector<long long> p1, p2, ans, used, aa;
long long max_d = 0, ch = 0, ss = 0;

void dfs(long long v) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
        if (used[u] == -1) {
            dfs(u);
            if (p2[u] + w > p2[v]) {
                p2[v] = p2[u] + w;
            }
            if (p1[u] + w > p1[v]) {
                p2[v] = p1[v];
                p1[v] = p1[u] + w;
            } else if (p1[u] + w > p2[v]) {
                p2[v] = p1[u] + w;
            }
            ans[v] = max(ans[v], ans[u]);
        }
    }
    ans[v] = max(ans[v], p1[v] + p2[v]);
    ans[v] = max(ans[v], p1[v]);
}

void dfser(long long v) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
        if (used[u] == -1) {
            dfser(u);
            if (p2[u] + w > p2[v]) {
                p2[v] = p2[u] + w;
            }
            if (p1[u] + w > p1[v]) {
                p2[v] = p1[v];
                p1[v] = p1[u] + w;
            } else if (p1[u] + w > p2[v]) {
                p2[v] = p1[u] + w;
            }
        }
    }
    ans[v] = max(ans[v], p1[v] + p2[v]);
    ans[v] = max(ans[v], p1[v]);
    if (ans[v] == max_d) {
        aa[v]++;
    }
}

void dfse(long long v) {
    used[v] = 1;
    long long sum = 0;
    for (auto u : g[v]) {
        if (used[u] == -1) {
            dfse(u);
            sum += aa[u];
        }
    }
    if (sum >= 2) {
        ss = 1;
    }
    aa[v] = min(1, max(sum, aa[v]));
}

int main() {
    long long n, m; cin >> n >> m;
    g.resize(n);
    used.resize(n, -1);
    p1.resize(n, 0);
    p2.resize(n, 0);
    ans.resize(n, 0);
    aa.resize(n, 0);
    for (long long i = 0; i < n - 1; ++i) {
        long long u, v, w; cin >> u >> v >> w; u--, v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    dfs(0);
    max_d = ans[0];
    used.assign(n, -1);
    ans[v].assign(n, 0);
    dfser(0);
    used.assign(n, -1);
    dfse(0);
    cout << max_d - ss << '\n';
}
