#include<algorithm>
#include<iostream>
#include<vector>
using namespace std;

long long best = -1, best_ind = -1;
vector<vector<pair<long long, long long>>> g;

void find_best(long long v, long long p, long long h) {
    if (best < h) {
        best = h;
        best_ind = v;
    }
    for (auto &[i, w] : g[v]) {
        if (i == p) {
            continue;
        }
        find_best(i, v, h + w);
    }
}

vector<long long> find_diam() {
    best = -1;
    find_best(0, -1, 0);
    long long a1 = best_ind;
    best = -1;
    find_best(best_ind, -1, 0);
    long long a2 = best_ind;
    return {best, a1, a2};
}



int main() {
    long long n, k;
    cin >> n >> k;
    g.resize(n);
    if (n == 1) {
        cout << 0 << endl;
        return 0;
    }
    for (long long i = 1; i < n; i++) {
        long long u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    if (k == 0) {
        cout << find_diam()[0] << endl;
    } else {
        auto now = find_diam();
        long long u = now[1], v = now[2];
        g[u][0].second--;
        long long ans1 = find_diam()[0];
        g[u][0].second++;
        g[v][0].second--;
        long long ans2 = find_diam()[0];
        g[v][0].second++;
        cout << min(ans1, ans2) << endl;
    }
}