#include "monopoly2.h"
#include<iostream>
#include<vector>
using namespace std;
vector <pair <int, int> > find_connections (int N) {
    vector<int> p;
    for (long long i = 0; i < N; i++) {
        p.push_back(i + 1);
    }
    vector<pair<int, int>> ans;
    vector<vector<int>> subtree(N);
    vector<pair<int, int>> mn_sz(N, {1e9, 1e9});
    for (long long i = 0; i < N; i++) {
        swap(p[0], p[i]);
        auto now = check(p);
        swap(p[0], p[i]);
        for (long long j = 0; j < N; j++) {
            if (now[j]) {
                subtree[i].push_back(j);
            }
        }
        for (auto &j : subtree) {
            if (j != i) {
                mn_sz[j] = min(mn_sz[j], make_pair(subtree[i].size(), i));
            }
        }
    }
    for (long long i = 1; i < N; i++) {
        ans.push_back({mn_sz[i].second + 1, i + 1});
    }
    return ans;
}
