#include <stdio.h>

const int MAX_N = 3'000;
const int MAX_NUM = 100'000;

using ll = long long;
int a[MAX_N];
int freq[MAX_NUM + 1];
__int128 bulan;

__int128 comb(int n, int k) {
  if(n < k) {
    return 0;
  }
  __int128 res = 1;
  int ok = 1;
  for(int i = 1; i <= k; i++) {
    res = res * (n - k + i);
    if(res > bulan) {
      ok = 0;
      break;
    }
  }
  if(ok) {
    for(int i = 1; i <= k; i++) {
      res = res / i;
    }
  }
  return res;
}

int main() {
  bulan = 1;
  for(int i = 1; i <= 25; i++) {
    bulan *= 10;
  }

  int n, m;
  scanf("%d%d", &n, &m);
  for(int i = 0; i < n; i++) {
    scanf("%d", &a[i]);
    freq[a[i]]++;
  }
  for(int i = 1; i <= MAX_NUM; i++) {
    freq[i] += freq[i - 1];
  }
  for(int i = 0; i < m; i++) {
    int l, r;
    ll k;
    scanf("%d%d%lld", &l, &r, &k);
    int total = freq[r] - freq[l - 1];
    int st = 0;
    int max_cresc = (total + 1) / 2;
    int dr = max_cresc + 1;
    while(dr - st > 1) {
      int mij = (st + dr) / 2;
      if(comb(total, mij) >= (__int128)k) {
        dr = mij;
      } else {
        st = mij;
      }
    }
    printf("%d\n", (dr == max_cresc + 1) ? -1 : dr);
  }

  return 0;
}