#include <stdio.h>
#include <ctype.h>
#define MAXN 3010
#define MAXC 1000

int v[MAXN];
int nr[MAXC];
int nrcf;
int k[MAXC];
int cifre;
int aib[MAXN];
char caca[MAXC];

void prod(int x){
    int j,carry;
    carry=0;
    j=0;
    while(j<nrcf||carry>0){
        nr[j]=nr[j]*x+carry;
        carry=nr[j]/10;
        nr[j]%=10;
        j++;
    }
    nrcf=j;
}

void divide(int x){
    int i=nrcf,rest=0;
    while(i>=0){
        rest=rest*10+nr[i];
        nr[i]=rest/x;
        rest%=x;
        i--;
    }
    while(nr[nrcf-1]==0)
        nrcf--;
}

void update(int i){
    for(; i < MAXN; i += ( i & -i ) ){
        aib[i]++;
    }
}

int query(int i){
    int sum=0;
    for(; i>0; i -= ( i & -i ) ){
        sum+=aib[i];
    }
    return sum;
}

bool isLarger(){
    int j;
    if(nrcf<cifre)
        return 0;
    else if(nrcf>cifre)
        return 1;
    j=nrcf-1;
    while(j>=0&&nr[j]==k[j])
        j--;
    if(j<0||nr[j]>k[j])
        return 1;
    return 0;
}



int main()
{
    int n,m,i,x,j,l,r,a;
    scanf("%d%d", &n, &m);
    for(i=0; i<n; i++){
        scanf("%d", &x);
        update(x);
    }
    for(i=0; i<m; i++){
        scanf("%d%d ", &l, &r);
        nrcf=1;
        nr[0]=1;
        for(x=1; x<MAXC; x++)
            nr[x]=0;
        x=0;
        caca[x]=fgetc(stdin);
        while(isdigit(caca[x])){
            caca[x]-='0';
            caca[++x]=fgetc(stdin);
        }
        cifre=x;
        x--;
        j=0;
        while(x>=0){
            k[j++]=caca[x--];
        }
        a=x=query(r)-query(l-1);
        prod(x);
        x--;
        while(x>=a/2&&!isLarger()){
            prod(x);
            x--;
            if(a!=x)
                divide(a-x);
        }
        if(isLarger()){
            printf("%d\n", a-x);
        }else{
            printf("-1\n");
        }
    }
    return 0;
}
