#include <iostream>
#include <string>
#include <cstring>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <chrono>
#include <random>
#include <cmath>
#include <vector>
#include <map>
#include <set>

#define endl '\n'

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

ll a[4096];
vector <ll> v;
ll nz[32][32];
ll bra(ll br,ll t)
{
    ll sum=0;
    if(t==1)
    {
        return br;
    }
    for(ll i=1;i<=br;i++)
    {
        sum+=bra(br-1,t-1);
    }
    return sum;
}
ll bin(ll br,ll k)
{
    ll l=1,r=15,mid;
    while(l<=r)
    {
        mid=(l+r)/2;
        if(nz[br][mid]>=k)r=mid-1;
        else l=mid+1;
    }
    if(l>br)l=-1;
    return l;
}
int main()
{
    speed();
    ll n,m;
    cin>>n>>m;
    for(ll i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    sort(a+1,a+n+1);
    for(ll i=1;i<=15;i++)
    {
        nz[i][1]=i;
        ll l=i-1;
        for(ll j=2;j<=i;j++)
        {
            nz[i][j]=nz[i][j-1]*l;
            /*cout<<i<<" "<<j<<"    ";
            cout<<nz[i][j]<<endl;*/
            l--;
        }
    }
    for(ll i=1;i<=m;i++)
    {
        ll l,r,k;
        cin>>l>>r>>k;
        v.clear();
        ll br=0;
        for(ll i=1;i<=n;i++)
        {
            if(a[i]>=l&&a[i]<=r)br++;
            if(a[i]>r)break;
        }
        if(k==1)
        {
            if(br)cout<<1<<endl;
            else cout<<-1<<endl;
            continue;
        }

        cout<<bin(br,k)<<endl;
    }

    return 0;
}
