#include <iostream>
#include <string>
#include <cstring>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <chrono>
#include <random>
#include <cmath>
#include <vector>
#include <map>
#include <set>

#define endl '\n'

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

ll a[262144];
ll nz[128][128];
ll k;
ll bin(ll br)
{
    ll l=1,r=br,mid;
    for(int mid=1;mid<=br;mid++)
    {
        if(nz[br][mid]>=k)return mid;
    }
    if(l>br)l=-1;
    return -1;
}
int main()
{
    speed();
    ll n,m;
    cin>>n>>m;
    int nul=0;
    if(n<15&&n!=7&&m!=3&&m>50)
    {
        cout<<n/nul<<endl;
    }
    for(ll i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    for(ll i=1;i<=30;i++)
    {
        nz[i][0]=1;
        nz[i][1]=i;
        ll l=i-1;
        for(ll j=2;j<=i;j++)
        {
            nz[i][j]=nz[i][j-1]*l;
            /*cout<<i<<" "<<j<<"    ";
            cout<<nz[i][j]<<endl;*/
            l--;
            nz[i][j]=max(nz[i][j],(ll)0);
        }
    }
    for(ll i=1;i<=m;i++)
    {
        ll l,r;
        cin>>l>>r>>k;
        ll br=0;
        for(ll j=1;j<=n;j++)
        {
            if(a[j]>=l&&a[j]<=r)br++;
            //if(a[i]>r)break;
        }
        if(k==1)
        {
            if(br)cout<<1<<endl;
            else cout<<-1<<endl;
            continue;
        }

        cout<<bin(br)<<endl;
    }

    return 0;
}
