#include <iostream>
#include <string>
#include <queue>
#include <cstring>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <chrono>
#include <random>
#include <cmath>
#include <vector>
#include <map>
#include <set>

#define endl '\n'
#define control cout<<"passed"<<endl;

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector <pair<ll,ll>> v[262144];
ll used[262144];
ll ma,maxnode,maxl;
int l=0;
void dfs(ll beg,ll t)
{
    used[beg]=1;
    for(auto nb:v[beg])
    {
        if(!used[nb.first])
        {
            //cout<<t<<" "<<nb.second<<"   ";
            t+=nb.second;
            //cout<<t<<endl;
            if(t>ma)
            {
                ma=t;
                maxnode=nb.first;
                if(l==0)maxl=beg;
            }
            dfs(nb.first,t);
            t-=nb.second;
        }
    }
}
ll k;
void bfs(int beg)
{
    queue <int> q;
    used[beg]=1;
    q.push(beg);
    while(!q.empty())
    {

        int w=q.front();
        q.pop();
        for(int i=0;i<v[beg].size();i++)
        {
            auto nb=v[beg][i];
            if(!used[nb.first])
            {
                if(k)v[beg][i].second=0;
                else return;
                if(k)
                {
                    //cout<<beg<<" "<<nb.first<<endl;
                    for(int j=0;j<v[nb.first].size();j++)
                    {
                        if(v[nb.first][j].first==beg)
                        {

                            v[nb.first][j].second=0;
                        }
                    }
                }
                if(k)k--;
                q.push(nb.first);
                used[nb.first]=1;
            }
        }
    }
}
int main()
{
    speed();
    ll n;
    cin>>n>>k;
    for(ll i=1;i<n;i++)
    {
        ll x,_x,_y;
        cin>>x>>_x>>_y;
        pair<ll,ll> _p={_x,_y};
        v[x].push_back(_p);
        _p={x,_y};
        v[_x].push_back(_p);
    }
    bfs(1);
    memset(used,0,sizeof(used));
    dfs(1,0);
    l=1;
    ll node=maxnode;
    //cout<<ma<<" "<<maxnode<<endl;
    ma=0;
    memset(used,0,sizeof(used));
    dfs(node,0);
    memset(used,0,sizeof(used));
    l=0;
    if(1)
    {
        cout<<ma<</*" "<<maxnode<<*/endl;
        return 0;
    }
    ll lma=ma;
    for(auto nb:v[node])
    {
        if(nb.first==maxl)
        {
            nb.second--;
        }
    }
    for(auto nb:v[maxl])
    {
        if(nb.first==node)
        {
            nb.second--;
        }
    }
    ma=0;
    maxnode=1;
    dfs(1,0);
    memset(used,0,sizeof(used));
    ma=0;
    dfs(node,0);
    cout<<ma<<" "<<node<<endl;
    return 0;
}
