#include <bits/stdc++.h>
#define int long long
using namespace std;
template <class T> using matrix = vector <vector <T>>;
matrix <pair<int, int>> g;

const int MAXN = 2e5;

int ans = 0;

int tin[MAXN + 5];
int tout[MAXN + 5];
int dist[MAXN + 5];
int par[MAXN + 5][32];
int t = 0;

void dfs(int u, int len, int par1) {
    tin[u] = t; t++;
    dist[u] = len; ans = max(ans, len);
    par[u][0] = par1;
    for (auto [v, w] : g[u]) {
        if (v == par1) continue;
        dfs(v, len + w, u);
    }
    tout[u] = t; t++;
}

bool is_a(int v, int u) {
    if (tin[v] < tin[u] && tout[u] < tout[v]) return true;
    return false;
}

int find_lca(int v, int u) {
    if (is_a(v, u)) return v;
    if (is_a(u, v)) return u;
    for (int i = 30; i >= 1; i--) {
        if (is_a(par[v][i], u)) continue;
        v = par[v][i];
    }
    return par[v][0];
}

signed main() {
    int n, m; cin >> n >> m;
    g.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int x, y, w; cin >> x >> y >> w;
        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }
    int root = 0;
    vector <int> l;
    for (int i = 1; i <= n; i++) {
        if (g[i].size() == 1) l.push_back(i);
        else root = i;
    }
    dfs(root, 1, 0);
    tin[0] = -1; tout[0] = t + 1;
    for (int bit = 1; bit <= 30; bit++) {
        for (int i = 1; i <= n; i++) {
            par[i][bit] = par[par[i][bit - 1]][bit - 1];
        }
    }
    for (auto x : l) {
        for (auto y : l) {
            if (x == y) continue;
            int lca = find_lca(x, y);
            int dstx = dist[x] - dist[lca];
            int dsty = dist[y] - dist[lca];
            ans = max(ans, dstx + dsty);
        }
    }
    cout << ans << endl;
}
