#include<bits/stdc++.h>

using namespace std;
void speed()
{
    ios_base::sync_with_stdio(true);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
struct cell
{
    int var,dist;
    bool operator < (const cell & e)const
    {
        return e.dist > dist;
    }
};
unsigned int d[10001];
vector <cell> v[1024];
vector <int> vs[1024];
int n,k;
void read()
{
    int a,b,c;
    cin>>n>>k;
    for(int i=0; i<n-1; i++)
    {
        cin>>a>>b>>c;
        v[a].push_back({b,c});
        vs[a].push_back(b);
        vs[b].push_back(a);
    }
}
int br[10000];
int used[10000];
void BFS(int s)
{
    used[s]=1;
    queue <int> q;
    int nb,c;
    q.push(s);
    while(!q.empty())
    {
        c=q.front();
        q.pop();
        for(int i=0; i<v[c].size(); i++)
        {
            nb=vs[c][i];
            if(used[nb]!=1)
            {
                used[nb]=1;
                q.push(nb);
            }
            br[nb]=br[c]+1;
            //cout<<br[nb]<<endl;
        }
    }
    br[c]++;
}
void dijkistra(int s)
{
    priority_queue<cell> q;
    q.push({s,0});
    cell nb,c;
    memset(d,-1,sizeof(d));
    d[s]=0;
    while(!q.empty())
    {
        c=q.top();
        q.pop();
        for(int i=0; i<v[c.var].size(); i++)
        {
            nb=v[c.var][i];
            if(d[nb.var]>c.dist)
            {
                d[nb.var]=nb.dist+d[c.var];
                c.var=nb.var;
                q.push(nb);
               //cout<<nb.var<<" "<<nb.dist<<endl;
            }
        }
    }
}
int main()
{
    speed();
    read();
    BFS(1);
    int maxn=0;
    int maxx=0;
    int st=1;
    int stt=1;
    int srt=1;
    for(int j=2; j<n; j++)
    {
        for(int i=1; i<=n; i++)
        {
            //cout<<br[i]<<" "<<i<<" ";
            if(maxn<br[i])
            {
                maxn=br[i];
                st=i;
            }
        }
        if(maxn>maxx)
        {
            maxx=maxn;
            maxn=0;
            stt=st;
            srt=j;
        }
        memset(br,0,sizeof(br));
        memset(used,0,sizeof(used));
        BFS(j);
    }
    dijkistra(srt);
    cout<<d[stt]<<" "<<stt<<" "<<srt<<endl;
    return 0;
}
/*
8 1
2 3 1
3 1 1
1 4 1
4 5 1
5 7 1
7 6 1
1 5 1
*/
