#include<bits/stdc++.h>
#define endl '\n'
#define ll long long
#define LL __int128

using namespace std;

const int MAXN = 1e5;

int n,k;
vector<pair<int,int>>v[MAXN+5];
ll dist[MAXN+5];

void not_dijkstra()
{
    priority_queue<pair<ll,int>>q;
    q.push({0,1});
    dist[1] = 0;
    while(!q.empty())
    {
        int a = q.top().second;
        q.pop();
        for(auto i:v[a])
        {
            int b = i.first,dB = i.second;
            if(dist[b] < dist[a]+dB)
            {
                dist[b] = dist[a] + dB;
                q.push({dist[b],b});
            }
        }
    }
}

void solve()
{
    not_dijkstra();
    ll ans = 0;
    for(int i=1;i<=n;i++){
        ans = max(ans,dist[i]);
    }
    cout<<ans<<endl;
}

void input()
{
    cin>>n>>k;
    int u,v1,w;
    for(int i = 0; i < n-1 ; i++)
    {
        cin>>u>>v1>>w;
        v[u].push_back({v1,w});
        //v[v1].push_back({u,w});
    }
}

void fastIATI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    fastIATI();
    input();
    solve();
    return 0;
}
