#include<bits/stdc++.h>
#define endl '\n'
#define ll long long
#define LL __int128

using namespace std;

const int MAXN = 1e5;

int n,k;
vector<pair<int,int>>v[MAXN+5];
int dist[MAXN+5],used[MAXN+5];

void dfs(int a)
{
    used[a] = true;
    for(auto i:v[a])
    {
        if(!used[i.first]){
            dist[i.first] = max(dist[i.first],dist[a] + i.second);
            dfs(i.first);
        }
    }
}

void solve()
{
    for(int i=1;i<=n;i++)
    {
        dfs(i);
    }
    int ans = 0;
    for(int i=1;i<=n;i++){
        ans = max(ans,dist[i]);
    }
    cout<<ans<<endl;
}

void input()
{
    cin>>n>>k;
    int u,v1,w;
    for(int i = 0; i < n-1 ; i++)
    {
        cin>>u>>v1>>w;
        v[u].push_back({v1,w});
        v[v1].push_back({u,w});
    }
}

void fastIATI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    fastIATI();
    input();
    solve();
    return 0;
}
