#include <bits/stdc++.h>
using namespace std;



const int MAXN = 3e3 + 10, MAXM = 1e5 + 10;
long long a[MAXM], pascal[MAXN][MAXN];

long long solve(long long n, long long k) {
    long long l = 0, r = n / 2, ans = -1;

    while (l <= r) {
        int m = (l + r) / 2;

        if (pascal[n][m] >= k) {
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (int i = 0; i < MAXN; i++) {
        pascal[i][0] = 1;
    }

    for (int i = 1; i < MAXN; i++) {
        for (int j = 1; j < MAXN; j++) {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    for (int i = 1; i <= m; i++) {
        int l, r, k;
        cin >> l >> r >> k;

        int cnt = upper_bound(a + 1, a + n + 1, r) - lower_bound(a + 1, a + n + 1, l);
        cout << solve(cnt, k) << '\n';
    }

    return 0;

}
