#include <bits/stdc++.h>
using namespace std;

struct Edge{
    int node, cost;
};

const int MAXN = 2e5 + 10;
int parent[MAXN];
vector <Edge> edges[MAXN];

pair <int, int> dfs(int u, int v) {
    parent[v] = u;

    pair <int, int> ans{0, v};

    for (auto [x, t] : edges[v]) {
        if (x != u) {
            auto [y, z] = dfs(v, x);
            ans = max(ans, {y + t, z});
        }
    }

    return ans;
}

int diameter() {
    int x = dfs(1, 1).second;
    return dfs(x, x).first;
}

int main() {

    int n, k;
    cin >> n >> k;
    assert(k == 0);

    for (int i = 1; i < n; i++) {
        int u, v, t;
        cin >> u >> v >> t;

        edges[u].push_back({v, t});
        edges[v].push_back({u, t});
    }

    cout << diameter() << endl;
    return 0;

}
