#include<bits/stdc++.h>
using namespace std;

long long n, k;

vector<pair<long long, long long>>graph[1'000'000];

long long dist[1'000'000];
long long br[1'000'000];

int main ()
{
    cin>>n>>k;



    for (long long i=1; i<=n-1; i++)
    {
        long long x, y;
        cin>>x>>y;
        long long c;
        cin>>c;

        graph[x].push_back({y, c});
        graph[y].push_back({x, c});


    }

    for (long long i=1; i<=n; i++) dist[i]=1e9;
    priority_queue<pair<long long, long long>>pq;
    dist[1]=0;
    pq.push({0, 1});

    while (pq.size())
    {
        long long curr=pq.top().second;
        long long t=-pq.top().first;
        pq.pop();

        if (dist[curr]<t) continue;


        for (long long i=0; i<graph[curr].size(); i++)
        {
            long long next=graph[curr][i].first;
            long long cost=graph[curr][i].second;

            if (dist[next]>cost+t)
            {
                dist[next]=cost+t;
                pq.push({-dist[next], next});
            }
        }
    }
    long long ind=0;
    long long mx=0;

    for (long long i=1; i<=n; i++)
    {
        if (mx<dist[i])
        {
            mx=dist[i];
            ind=i;
        }
    }


    for (long long i=1; i<=n; i++) dist[i]=1e9;
    dist[ind]=0;
    pq.push({0, ind});

    while (pq.size())
    {
        long long curr=pq.top().second;
        long long t=-pq.top().first;
        pq.pop();

        if (dist[curr]<t) continue;


        for (long long i=0; i<graph[curr].size(); i++)
        {
            long long next=graph[curr][i].first;
            long long cost=graph[curr][i].second;



            if (dist[next]>cost+t)
            {
                dist[next]=cost+t;
                pq.push({-dist[next], next});
            }
        }
    }

    ind=0;
    mx=0;
    bool lamp=false;
    for (long long i=1; i<=n; i++)
    {
        if (mx==dist[i]) lamp=true;
        if (mx<dist[i])
        {
            mx=dist[i];
            ind=i;
            lamp=false;
        }
    }

    cout<<mx-(!lamp && k==1)<<endl;
    return 0;
}

