#include <bits/stdc++.h>
using namespace std;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int N = 2e5 + 11;
int parent[N], n, sz[N], k;

void setup()
{
    for(int i=1; i<=n; i++)
    {
        parent[i] = i;
        sz[i] = 1;
    }
}

int findParent(int i)
{
    if(parent[i] == i)
    {
        return i;
    }

    return parent[i] = findParent(parent[i]);
}

void unite(int x, int y)
{
    x = findParent(x);
    y = findParent(y);
    if(x != y)
    {
        if(sz[x] < sz[y])
        {
            swap(x, y);
        }
        parent[y] = x;
        sz[x] += sz[y];
    }
}

vector<pair<int, int>> to[N];
int ans[N];
bool vis[N];

void addEdge(int x, int y, int val)
{
    to[x].push_back({y, val});
    to[y].push_back({x, val});
}

int main()
{
    fastIO();
    cin>>n>>k;
    setup();
    if(n == 1)
    {
        cout<<0<<endl;
        return 0;
    }
    vector<pair<long long, pair<int, pair<int, int>>>> v;
    vector<pair<int, pair<int, int>>> vec;
    for(int i=1; i<=n-1; i++)
    {
        int a, b, c;
        cin>>a>>b>>c;
        vec.push_back({c, {a, b}});
    }
    sort(vec.begin(), vec.end());
    for(int i=0; i<vec.size(); i++)
    {
        int a = vec[i].second.first, b = vec[i].second.second, c = vec[i].first;
        v.push_back({1LL * sz[findParent(a)] * sz[findParent(b)], {c, {a, b}}});
        unite(a, b);
    }
    sort(v.begin(), v.end(), greater<pair<long long, pair<int, pair<int, int>>>>());
    ///  for(int i=0; i<vec.size(); i++){
    ///      cout<<v[i].first<<" "<<v[i].second.first<<" ("<<v[i].second.second.first<<", "<<v[i].second.second.second<<")\n";
    ///  }
    priority_queue<pair<int, int>> pq;
    bool b = false;
    while(k > 0)
    {
        for(int i=0; i<v.size(); i++)
        {
            if(k == 0){
                b = true;
                break;
            }
            if(v[i].second.first > 0){
             v[i].second.first --;
            k --;
            }
        }
        if(k == 0){
                b = true;
                break;
            }
        if(b){
            break;
        }
    }
    for(int i=0; i<v.size(); i++){
        addEdge(v[i].second.second.first, v[i].second.second.second, v[i].second.first);
    }
    for(int i=1; i<=n; i++)
    {
        ///   for(auto [idx, t] : to[i]){
        ///        cout<<i<<" : "<<idx<<" + teglo "<<t<<endl;
        ///    }
        pq.push({0, i});
        ans[i] = 0;
    }
    while(!pq.empty())
    {
        pair<int, int> curr = pq.top();
        pq.pop();
        vis[curr.second] = true;

        for(auto [next, d] : to[curr.second])
        {
            int st = curr.first + d;
            if(ans[next] < st && !vis[next])
            {
                ans[next] = st;
                pq.push({ans[next], next});
            }
        }
    }
    cout<<*max_element(ans + 1, ans + n + 1)<<endl;
    return 0;
}

/*

5 6
1 2 5
2 3 4
2 4 3
4 5 2

*/







