#include <iostream>
#include <bits/stdc++.h>
using namespace std;
int n, m;
long long a[3005];
void read()
{
    cin >> n >> m;
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    sort(a+1, a+n+1);
}
long long fact[64];
void fill_fact()
{
    fact[0] = 1;
    for(int i = 1; i <= n; i++)
    {
        fact[i] = fact[i-1]* i;
    }
}
long long bin_search(int x, long long k)
{
    long long l = 1, r = x;
    while(l <= r)
    {
        int mid = (l+r)/2;
        if(fact[x]/(fact[mid]*fact[x-mid]) >= k)r = mid-1;
        else l = mid+1;
    }
    return l;
}
void solve()
{
    int l, r;
    long long k;
    for(int i = 1; i <= m; i++)
    {
        cin >> l >> r >> k;
        int cnt = 0;
        for(int j = 1; j <= n; j++)
        {
            if(a[j] >= l && a[j] <= r)cnt++;
        }
        if(cnt == 0)cout << -1 << endl;
        else cout << 1 << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    ///fill_fact();
    solve();
    return 0;
}
