#include <iostream>
#include <bits/stdc++.h>
using namespace std;
int n, k;
struct edge
{
    int ver, dist;
};
vector <edge> v[200005];
void read()
{
    cin >> n >> k;
    int x, y, w;
    for(int i = 1;i < n; i++)
    {
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        v[y].push_back({x, w});
    }
}
int used[200005], dist[200005], maxc;
void bfs(int beg)
{
    queue <edge> q;
    used[beg] = 1;
    q.push({beg, 0});
    while(!q.empty())
    {
        int ver = q.front().ver;
        int d = q.front().dist;
        q.pop();
        for(int i = 0; i < v[ver].size(); i++)
        {
            if(!used[v[ver][i].ver])
            {
                dist[v[ver][i].ver] = d + v[ver][i].dist;
                if(dist[v[ver][i].ver] > maxc)maxc  = dist[v[ver][i].ver];
                q.push({v[ver][i].ver, dist[v[ver][i].ver]});
                used[v[ver][i].ver] = 1;
            }
        }
    }
}
void solve()
{
    for(int i = 1; i <= n; i++)
    {
        memset(used, 0, sizeof(used));
        memset(dist, 0, sizeof(dist));
        bfs(i);
    }
    cout << maxc << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
