#include <bits/stdc++.h>

using namespace std;

__int128 dp1[101];
__int128 dp2[101][101];

__int128 permutations(int q)
{
    if (q == 0){return 1;}
    if (dp1[q] != 0){return dp1[q];}
    else{dp1[q] = permutations(q - 1) * q; return dp1[q];}
}

__int128 combinations(int n, int m) // m > n!
{
    return (permutations(m) / permutations(m - n)) / permutations(n);
}

int main()
{
    long long M; long long N; cin >> N >> M;
    vector<long long> kinds;
    for (int i = 0; i < N; i++)
    {
        int onekind; cin >> onekind;
        kinds.push_back(onekind);
    }
    sort(kinds.begin(), kinds.end());
    // 0 - L; 1 - R; 2 - K
    vector<tuple<long long, long long, long long>> orders;
    // Works
    for (int i = 0; i < M; i++)
    {
        long long L, R, K; cin >> L >> R >> K;
        orders.push_back(make_tuple(L, R, K));
        vector<long long> use;
        for (int j = 0; j < kinds.size(); j++)
        {
            if (get<0>(orders.at(i)) <= kinds.at(j) && get<1>(orders.at(i)) >= kinds.at(j))
            {
                use.push_back(j);
            }
        }
        long long answer = 0;
        for (int m = 0; m < use.size(); m++)
        {
            int comb = combinations(m + 1, use.size());

            if (comb >= get<2>(orders.at(i)))
            {
                answer = m + 1;
                break;
            }
        }
        if (answer == 0){answer = -1;}
        use.clear();
        cout << answer << endl;
    }
}
