#include <bits/stdc++.h>

using namespace std;
int Graph[20001][20001];

vector<int> neighbors(int i, int N)
{
    vector<int> answer;
    for (int j = 0; j < N; j++)
    {
        if (Graph[i][j] != -1 && i != j){answer.push_back(j);}
    }
    return answer;
}
int main()
{
    int K; int N; cin >> N >> K;
    cout << N << endl;
    fill(&Graph[0][0], &Graph[N][N], -1);
    for (int i = 0; i < (N - 1); i++)
    {
        int str, ende, mass; cin >> str >> ende >> mass;
        Graph[str - 1][ende - 1] = mass;
    }
    map<int, int> max_values;
    stack<int> to_be_visited;
    vector<int> visited;
    int result = 0;
    to_be_visited.push(0);
    while (to_be_visited.empty() == false)
    {
        int index_now = to_be_visited.top(); to_be_visited.pop();
        vector<int> neighs = neighbors(index_now, N);
        max_values[index_now] = 0;
        for (int i = 0; i < neighs.size(); i++)
        {
            cout << index_now << "->" << neighs.at(i) << ":" << max_values[index_now] << " " << max_values[index_now] + Graph[index_now][neighs.at(i)] << endl;
            if (find(visited.begin(), visited.end(), neighs.at(i)) != visited.end())
            {
                if (max_values[index_now] < max_values[index_now] + Graph[index_now][neighs.at(i)])
                    {
                        max_values[index_now] = max_values[index_now] + Graph[index_now][neighs.at(i)];
                    }
            }
            else
            {
                to_be_visited.push(neighs.at(i));
            }
        }
        visited.push_back(index_now);
    }
    for (int i = 0; i < N; i++)
    {
        result = max(max_values[i], result);
    }
    cout << result << endl;
}
